<?php
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', './../../');

define('FORUM_SKIP_CSRF_CONFIRM', 1);
define('FORUM_DISABLE_CSRF_CONFIRM', 1);

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/profile.php';
require FORUM_ROOT.'extensions/live_chat/resizeimage.php';

if (file_exists(FORUM_ROOT.'extensions/live_chat/lang/'.$forum_user['language'].'/live_chat.php'))
	require FORUM_ROOT.'extensions/live_chat/lang/'.$forum_user['language'].'/live_chat.php';
else
	require FORUM_ROOT.'extensions/live_chat/lang/English/live_chat.php';

if (isset($_GET['action']))
	define('FORUM_QUIET_VISIT', 1);

forum_session_start();

$chat_config = ($forum_user['live_chat'] != '') ? unserialize($forum_user['live_chat']) : array();

if (defined('BLACK_LIST_LOADED')) {
	$use_black_list = true;
    if ($use_black_list == true && !empty($forum_user['black_list']))
	    $black_list = unserialize($forum_user['black_list']);
}

$action = isset($_GET['action']) ? $_GET['action'] : null;

if ($action == 'add')
{
    if (!$forum_user['is_guest'] OR $forum_config['o_live_chat_can_guest'] == '1') {
	    if (count($_POST) > 0 && empty($_POST['email'])) {
	
	        $errors = array();
	
	        if (!$forum_user['is_guest']) {
	            $author  = $forum_user['username'];
		        $user_id = $forum_user['id'];
	        } else {
	            $author  = $_POST['chat_author'];
		        $user_id = 1;

		        $errors = array_merge($errors, validate_username($author));
	        }

	        $tab = isset($_POST['tab']) ? intval($_POST['tab']) : 1;
			$r_user_id = isset($_POST['user_id']) ? intval($_POST['user_id']) : 0;

			if ($tab == 1) { $maxlength = $forum_config['o_live_chat_message_max_len']; } elseif ($tab == 2) { $maxlength = $forum_config['o_live_chat_private_message_max_len']; }
			
			$message = strip_tags($_POST['message']);
			$msg_length = str_replace(array("\t","\n","\r\n","\0","\v"),"",$message);
			$msg_length = preg_replace('/\[\s*img.*\][^[]*\[\s*\/img.*\]|\[[^\]]+\]|\[\s*quote.*\][^[]*\[\s*\/quote.*\]|\[[^\]]+\]/i', '', $msg_length);
 
	        if ($message == '' || $msg_length == '')
		        $errors[] = $lang_live_chat['Field message that required'];
	        if (mb_strlen($msg_length, "UTF-8") > $maxlength)
		        $errors[] = sprintf($lang_live_chat['Error message length'], $maxlength);
		    if ($forum_config['o_censoring'] == '1' && censor_words($message) != $message)
		        $errors[] = $lang_live_chat['Error message censor'];
	        if ($tab == 1 && !$forum_user['is_admmod'] && !$forum_user['g_moderator'] == '1') {
				if (preg_match('/(http(s)?:\/\/)?(ftp(s)?:\/\/)?(www\.)?([-а-яa-zёЁцушщхъфырэчстью0-9_\.]{2,}\.)(рф|[a-z]{2,6})/i', $message) && !preg_match('\''.$base_url.'\'', $message))
		            $errors[] = $lang_live_chat['Error include url'];
			}
			
	        if (is_banned($author)) {
                echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error banned username'].'</p>'));
				
			    die;
			} elseif ($chat_config['status'] == 4) {
                echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error silent mode'].'</p>'));
				
				die;
			} elseif ($chat_config['status'] == 2) {
                echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error offline mode'].'</p>'));
				
			    die;
			} elseif ($tab == 1 && $forum_config['o_live_chat_posted_period'] > 0 && check_messages_period() == FALSE) {
			    echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.sprintf($lang_live_chat['Error message period'], $forum_config['o_live_chat_posted_period']).'</p>'));
				
			    die;
			} elseif ($tab == 2 && !$forum_user['is_admmod'] && get_private_messages_count() >= $forum_config['o_live_chat_limit_private_messages']) {
			    echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.sprintf($lang_live_chat['Error private message limit'], $forum_config['o_live_chat_limit_private_messages']).'</p>'));
				
			    die;
            } elseif ($tab == 2 && !$forum_user['is_admmod'] && $r_user_id > 1 && get_private_messages_count('user_box', $r_user_id) >= $forum_config['o_live_chat_limit_private_messages']) {
			    echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error user box is full'].'</p>'));
				
			    die;
            }elseif(!empty( $author ) && !empty( $message ) && empty($errors)) {
				
				if ($tab == 1) {
					$user_ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '0.0.0.0';

		            $query = array(
			            'INSERT'		=> 'user_id, author, message, user_ip, date',
			            'INTO'			=> 'live_chat',
			            'VALUES'	    => '\''.$forum_db->escape($user_id).'\', \''.$forum_db->escape($author).'\', \''.$forum_db->escape($message).'\', \''.$forum_db->escape($user_ip).'\', \''.time().'\''
		            );
		            $forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			        if ($forum_config['o_live_chat_auto_delete'] > 0) {
			            check_messages_count();
                    }
                } elseif ($tab == 2 && $forum_config['o_live_chat_private_chat'] == '1' && !$forum_user['is_guest'] && $r_user_id > 1 && check_user($r_user_id) == true) {
	                $private_chat_user = $r_user_id;

					$query = array(
			            'INSERT'		=> 'from_id, to_id, message, send',
			            'INTO'			=> 'live_chat_private',
			            'VALUES'	    => '\''.$forum_db->escape($user_id).'\', \''.$forum_db->escape($private_chat_user).'\', \''.$forum_db->escape($message).'\', \''.time().'\''
		            );
		            $forum_db->query_build($query) or error(__FILE__, __LINE__);
	            } else {
					echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Unknown error'].'</p>'));
				
			        die;
				}
            } else {
			    $r_data = array();
		        foreach ($errors as $cur_error) {
			        $r_data[] = '<p style="color:red;">'.$cur_error.'</p>';
			    }
			
			    $res = implode('', $r_data);
			    echo json_encode(array('answer'=>'error', 'error'=>$res));
				
			    die;
            }

            echo json_encode(array('answer'=>'success'));
				
            die;
	    }
    }	
}

else if ($action == 'upload_file')
{
	$tab = isset($_POST['tab']) ? intval($_POST['tab']) : 1;

	if (!$forum_user['is_guest'] && ($tab == 2 || $forum_config['o_live_chat_upload_images'] == '1' || $forum_user['is_admmod']))
	{
		if(isset($_FILES['file']) && $_FILES['file']['error'] == 0)
		{
		    $r_user_id = isset($_POST['user_id']) ? intval($_POST['user_id']) : 0;
			
			if (is_banned($forum_user['username'])) {
                echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error banned username'].'</p>'));
				
			    die;
		    } elseif ($chat_config['status'] == 4) {
                echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error silent mode'].'</p>'));
				
		        die;
		    } elseif ($chat_config['status'] == 2) {
                echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error offline mode'].'</p>'));
				
			    die;
	        } elseif ($tab == 1 && $forum_config['o_live_chat_posted_period'] > 0 && check_messages_period() == FALSE) {
			    echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.sprintf($lang_live_chat['Error message period'], $forum_config['o_live_chat_posted_period']).'</p>'));
				
			    die;
		    } elseif ($tab == 2 && !$forum_user['is_admmod'] && get_private_messages_count() >= $forum_config['o_live_chat_limit_private_messages']) {
			    echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.sprintf($lang_live_chat['Error private message limit'], $forum_config['o_live_chat_limit_private_messages']).'</p>'));
				
			    die;
            } elseif ($tab == 2 && !$forum_user['is_admmod'] && $r_user_id > 1 && get_private_messages_count('user_box', $r_user_id) >= $forum_config['o_live_chat_limit_private_messages']) {
			    echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error user box is full'].'</p>'));
				
			    die;
            }

		    $tmp_name = $_FILES['file']['tmp_name'];
		    $file_name = strtolower(translit_attach_file($_FILES['file']['name']));
		    $extension = strtolower(pathinfo($_FILES['file']['name'], PATHINFO_EXTENSION));
            $image_types = array('jpg', 'jpeg', 'png', 'gif');
		    $file_size = isset($_FILES['file']['size']) ? $_FILES['file']['size'] : 'undefined';
		    $base_name = md5($file_name.time()).'.'.$extension;

		    if (in_array($extension, $image_types))
		    {
			    $image_link = 'uploads/live_chat_attachments/'.$forum_user['id'].'/'.$base_name;
		        $path_to_image = FORUM_ROOT.'uploads/live_chat_attachments/'.$forum_user['id'].'/'.$base_name;
		        $dir = FORUM_ROOT.'uploads/live_chat_attachments/'.$forum_user['id'].'/';

			    if (!file_exists($dir)) {
                    @mkdir($dir);
                    @chmod($dir, 0777);
                }

			    if (move_uploaded_file($tmp_name, $path_to_image) )
			    {
				    $file_type = 'image';
				    rename($path_to_image, $dir.$base_name);
					
				    if (file_exists($dir.$base_name) )
				    {
					    $new_image = $dir.$base_name;
						$max_width = 700;
						$max_height = 500;

					    list($width, $height) = getimagesize($new_image);
					    if ($width > $max_width OR $height > $max_width)
					    {
						    try {
							    $resize = new \Eventviva\ImageResize($new_image);
							    $resize->resizeToBestFit($max_width, $max_height); //resize, resizeToHeight, resizeToWidth, resizeToBestFit;
							    $resize->save($new_image, null, 80); //80 = image quality;
							    $image_size = filesize($new_image);
						    } catch(Exception $e) {
						        echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error upload image'].'</p>'));
				
	                            die;
						    }
							
					    } else {
						    $image_size = $file_size;
					    }

                        $user_ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '0.0.0.0';

				        if ($tab == 1) {
		                    $query = array(
			                    'INSERT'		=> 'user_id, author, message, user_ip, date',
			                    'INTO'			=> 'live_chat',
			                    'VALUES'	    => '\''.$forum_db->escape($forum_user['id']).'\', \''.$forum_db->escape($forum_user['username']).'\', \'attach_image\', \''.$forum_db->escape($user_ip).'\', \''.time().'\''
		                    );
		                    $forum_db->query_build($query) or error(__FILE__, __LINE__);

                            $msg_id = $forum_db->insert_id();
					        $query = array(
						        'INSERT'	=> 'msg_id, chat_type, user_id, file_name, file_url, file_type, file_ext, file_size',
						        'INTO'		=> 'live_chat_attachments',
						        'VALUES'	=> '\''.$forum_db->escape($msg_id).'\', '.$tab.', \''.$forum_db->escape($forum_user['id']).'\', \''.$forum_db->escape($file_name).'\', \''.$forum_db->escape($image_link).'\', \''.$forum_db->escape($file_type).'\', \''.$forum_db->escape($extension).'\', \''.$forum_db->escape($image_size).'\'',
					        );
					        $forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			                if ($forum_config['o_live_chat_auto_delete'] > 0) {
			                    check_messages_count();
                            }
                        } elseif ($tab == 2 && $forum_config['o_live_chat_private_chat'] == '1' && $r_user_id > 1 && check_user($r_user_id) == true) {
					        $query = array(
			                    'INSERT'		=> 'from_id, to_id, message, send',
			                    'INTO'			=> 'live_chat_private',
			                    'VALUES'	    => '\''.$forum_db->escape($forum_user['id']).'\', \''.$forum_db->escape($r_user_id).'\', \'attach_image\', \''.time().'\''
		                    );
		                    $forum_db->query_build($query) or error(__FILE__, __LINE__);
					
					        $msg_id = $forum_db->insert_id();
					        $query = array(
						        'INSERT'	=> 'msg_id, chat_type, user_id, file_name, file_url, file_type, file_ext, file_size',
						        'INTO'		=> 'live_chat_attachments',
						        'VALUES'	=> '\''.$forum_db->escape($msg_id).'\', '.$tab.', \''.$forum_db->escape($forum_user['id']).'\', \''.$forum_db->escape($file_name).'\', \''.$forum_db->escape($image_link).'\', \''.$forum_db->escape($file_type).'\', \''.$forum_db->escape($extension).'\', \''.$forum_db->escape($image_size).'\'',
					        );
					        $forum_db->query_build($query) or error(__FILE__, __LINE__);
	                    } else {
					        echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Unknown error'].'</p>'));
				
			                die;
				        }
						
						echo json_encode(array('answer'=>'success'));
				
                        die;
				    }
			    }
		    } else {
	            $image_types = implode(', ', $image_types);
				
			    echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.sprintf($lang_live_chat['Error image types'], $image_types).'</p>'));
				
	            die;
		    }
		}
		
		echo json_encode(array('answer'=>'error', 'error'=>'<p style="color:red;">'.$lang_live_chat['Error upload image'].'</p>'));
				
	    die;
	}
}

else if ($action == 'refresh')
{
	if (isset($_GET)) {
		
		$tab = isset($_GET['tab']) ? intval($_GET['tab']) : 1;
		$user_id = isset($_GET['user_id']) ? intval($_GET['user_id']) : 0;
		$u_profiles = isset($chat_config['user_profiles']) ? $chat_config['user_profiles'] : 1;
		$img_height = $forum_config['o_live_chat_max_height'] - 50;
		$i_messages = isset($chat_config['inversion_messages']) ? $chat_config['inversion_messages'] : 0;
		$s_color = isset($chat_config['separate_color']) ? $chat_config['separate_color'] : 0;
		$u_status = isset($chat_config['status']) ? $chat_config['status'] : 1;
		$public_last_entry = get_last_message();
		$private_last_entry = get_last_private_message();
		$new_public_msg_count = get_new_public_messages_count();
		$new_private_msg_count = get_new_private_messages_count();
		$cur_count = get_private_messages_count();
		$cur_percent = ($cur_count / $forum_config['o_live_chat_limit_private_messages']) * 100;
		
		if (!$forum_user['is_admmod']) {
		    if ((int)$cur_percent >= 90 && (int)$cur_percent < 100) {
			    $box_count = sprintf($lang_live_chat['Attention box is nearly full'], (int)$cur_percent);
		    } elseif ((int)$cur_percent >= 100) {
			    $box_count = sprintf($lang_live_chat['Attention box is full'], $forum_config['o_live_chat_limit_private_messages']);
		    } else {
			    $box_count = 0;
		    }
		} else {
			$box_count = 0;
		}

		if ($tab == 1 && (!$forum_user['is_guest'] OR $forum_config['o_live_chat_can_guest'] == '1')) {
			$query = array(
		        'SELECT'	=> 'c.*, u.avatar, u.avatar_width, u.avatar_height, u.live_chat, a.file_name, a.file_url',
		        'FROM'		=> 'live_chat AS c',
		        'JOINS'		=> array(
			        array(
				        'LEFT JOIN'		=> 'users AS u',
				        'ON'		    => 'u.id=c.user_id',
			        ),
					array(
				        'LEFT JOIN'		=> 'live_chat_attachments AS a',
				        'ON'		    => 'a.msg_id=c.id AND a.chat_type=1',
			        )
		        ),
		        'ORDER BY'	=> 'date DESC',
		        'LIMIT'	    => $forum_config['o_live_chat_messages_count']
	        );
			
			if (isset($black_list)) {
		        $query['WHERE'] = 'c.user_id NOT IN ('.implode(',', $black_list).')';
			}

            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	        if  ($forum_user['is_admmod'] OR $forum_user['g_moderator'] == '1') {
				if (isset($_SESSION['chat_admin_func']) && $_SESSION['chat_admin_func'] != '') {
			        $admin_func = $_SESSION['chat_admin_func'];
				} else {
					$admin_func = 'none';
						
			    }
			    $admin_button = 1;
			} else  { 
				$admin_func = 'none';
				$admin_button = 0; 
			}
			
			if ($forum_user['is_admmod'] || (!$forum_user['is_guest'] && $forum_config['o_live_chat_upload_images'] == '1')) { $upload_button = 1; } else { $upload_button = 0; }
			
			if ($forum_db->num_rows($result) > 0) {

                $counter = 1;
				$s_data = array();
                    while ($array = $forum_db->fetch_assoc($result)) {
						$u_array = unserialize($array['live_chat']);

						$message = $array['message'];
						if ($forum_config['p_message_bbcode'] == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false) {
				            $message = parse_bbcode($message);
				        }

				        $message = preg_replace('/\[\s*img.*\][^[]*\[\s*\/img.*\]|\[[^\]]+\]|\[\s*quote.*\][^[]*\[\s*\/quote.*\]|\[[^\]]+\]/i', '', $message);
				
				        if ($forum_config['o_make_links'] == '1') {
				            $message = parse_links($message);
				        }

	                    if ($forum_config['o_smilies'] == '1') {
					        $message = parse_smilies($message);
	                    }
						
						if (!$forum_user['is_guest'] AND $s_color == '1') {
	                        if ($counter == 2) { $msg_class = 'my'; $counter = 0; } else { $msg_class = ''; }
						} else {
							$msg_class = '';
						}

						$no_avatar = '<img src="'.$base_url.'/extensions/live_chat/css/no_avatar.jpg" alt="No avatar">';
		                if ($array['user_id'] > 1) {
		                    if ($forum_config['o_avatars'] == '1' && $forum_user['show_avatars'] != '0') {
			                    $u_avatar = generate_avatar_markup($array['user_id'], $array['avatar'], $array['avatar_width'], $array['avatar_height'], $array['author']);
			                    if (!empty($u_avatar)) { $user_avatar = $u_avatar; } else { $user_avatar = $no_avatar; }
		                    } else {
				                $user_avatar = $no_avatar;
			                }
		                } else {
			                $user_avatar = $no_avatar;
		                }
						
						if (is_banned($array['author'], $array['user_ip'])) { 
						    $status = 'banned'; $s_title = $lang_live_chat['Banned']; 
						} elseif ($array['user_id'] > 1 AND $u_array['status'] == 4) { 
						    $status = 'silent'; $s_title = $lang_live_chat['Silent']; 
						} elseif ($array['user_id'] > 1 AND $u_array['status'] == 3) { 
						    $status = 'not-disturb'; $s_title = $lang_live_chat['Do not disturb'];
						} elseif ($array['user_id'] > 1 AND $u_array['status'] == 2) { 
						    $status = 'offline'; $s_title = $lang_live_chat['Offline'];
						} elseif ($u_array['status'] == 1) { 
						    if (is_online($array['user_id'], $array['user_ip'])) { 
						        $status = 'online'; $s_title = $lang_live_chat['Online']; 
						    } else { 
						        $status = 'offline'; $s_title = $lang_live_chat['Offline'];
					        }
						}
						
						if ($forum_user['is_guest'] OR $u_profiles == '1') {
						    $user_link = '<span class="user chat_profile" msg_id="'.$array['id'].'" user_status="'.$status.'" side="'.$msg_class.'">'.$user_avatar.'<i class="user-status user-status-'.$status.'"></i></span>';
						} else {
							if ($forum_user['g_view_users'] == '1' && $array['user_id'] > 1) {$user_link = '<a class="user" title="'.sprintf($lang_profile['Users profile'], forum_htmlencode($array['author'])).'" href="'.forum_link($forum_url['user'], $array['user_id']).'" target="_blank">'.$user_avatar.'<i class="user-status user-status-'.$status.'" title="'.$s_title.'"></i></a>';} else {$user_link = '<span class="user">'.$user_avatar.'<i class="user-status user-status-'.$status.'" title="'.$s_title.'"></i></span>';}
						}

					    if ($array['user_id'] != 1) { $username = $array['author']; } else { $username = $array['author'].' '.$lang_live_chat['Guest']; }
						if ($message == 'attach_image') { $msg_txt = '<div class="text_img"><a class="fancybox" rel="group" href="'.$base_url.'/'.$array['file_url'].'" target="_blank"><img style="max-height:'.$img_height.'px;" alt="'.$array['file_name'].'" src="'.$base_url.'/'.$array['file_url'].'" /></a></div>'; } else { $msg_txt = '<div class="text_msg edit_chat_msg_'.$array['id'].'">'.$message.'</div>'; }
//						if ($message == 'attach_image') { $msg_txt = '<div class="text_img"><img style="max-height:'.$img_height.'px;" alt="'.$array['file_name'].'" src="'.$base_url.'/'.$array['file_url'].'" /></img></div>'; } else { $msg_txt = '<div class="text_msg edit_chat_msg_'.$array['id'].'">'.$message.'</div>'; }
						if (($forum_user['is_admmod'] OR $forum_user['g_moderator'] == '1') && $array['user_id'] > 1 && $array['user_id'] != $forum_user['id']) { $silent_link = '<a class="msg_user_silent" href="#" title="'.$lang_live_chat['Silent mode'].'" onclick="Silent_user('.$array['user_id'].'); return false;"></a>'; } else { $silent_link = ''; }
						if ($forum_user['is_admmod'] && $array['user_id'] != $forum_user['id']) { $ban_link = '<a class="msg_user_ban" href="#" title="'.$lang_live_chat['Ban'].'" onclick="Ban_user('.$array['id'].'); return false;"></a>'; } else { $ban_link = ''; }
						if ($message != 'attach_image' && ($forum_user['is_admmod'] OR $forum_user['g_moderator'] == '1')) { $edit_link = '<a class="msg_edit" href="#" title="'.$lang_live_chat['Edit message'].'" onclick="Edit_message('.$array['id'].'); return false;"></a>'; } else { $edit_link = ''; }
						if ($forum_user['is_admmod'] OR $forum_user['g_moderator'] == '1') { $delete_link = '<a class="msg_delete" href="#" title="'.$lang_live_chat['Delete message'].'" onclick="Delete_message('.$array['id'].'); return false;"></a>'; } else { $delete_link = ''; }

						$s_data[] = '<div class="chat_message c_msg_'.$array['id'].' '.$msg_class.'">'.$user_link.'<div class="body_msg"><div class="header_msg"><a class="author" href="#" style="color:'.$u_array['user_color'].';"  user_id="'.$array['user_id'].'" user_name="'.$username.'" onclick="Get_chat_user(this); return false;">'.$username.'</a><span class="date">'.get_adjusted_date($array['date']).'</span></div>'.$msg_txt.'<div class="footer_msg" style="display:'.$admin_func.';">&nbsp;<span class="moderate_block">'.$delete_link . $edit_link . $ban_link . $silent_link.'</span></div></div></div>';	

                    $counter++;
	                }

				if (!$forum_user['is_guest'] AND $i_messages == '1') {
				    $res = implode('', $s_data);
				} else {
					$res = implode('', array_reverse($s_data));
				}

                echo json_encode(array('answer'=>'success','head_desc'=>0,'box_count'=>0,'show_form'=>1,'upload_button'=>$upload_button,'admin_button'=>$admin_button,'content'=>$res,'public_last_entry'=>$public_last_entry,'private_last_entry'=>$private_last_entry,'public_notify'=>$new_public_msg_count,'private_notify'=>$new_private_msg_count,'user_status'=>$u_status));
				
                die;
	        } else {
	            echo json_encode(array('answer'=>'success','head_desc'=>0,'box_count'=>0,'show_form'=>1,'upload_button'=>$upload_button,'admin_button'=>$admin_button,'content'=>'<div>'.$lang_live_chat['Empty'].'</div>','public_last_entry'=>$public_last_entry,'private_last_entry'=>$private_last_entry,'public_notify'=>$new_public_msg_count,'private_notify'=>$new_private_msg_count,'user_status'=>$u_status));
				
                die;
	        }
		} elseif ($tab == 2 && !$forum_user['is_guest']) {
            if (isset($user_id) && $user_id > 1) {
                $private_chat_user = $user_id;
				$c_username = get_username($private_chat_user, 'get_real_username');
				$msg_count = get_private_messages_count('chat_box', $private_chat_user);
				$head_desc = '<span class="desc_left">'.$lang_live_chat['Chat with'].' <strong><a title="'.$lang_live_chat['User profile'].'" href="'.forum_link($forum_url['user'], $private_chat_user).'" target="_blank">'.$c_username.'</a></strong></span><span class="desc_right">'.$lang_live_chat['Messages'].' ('.$msg_count.')</span>';

				$read_messages = array(
		            'UPDATE'	=> 'live_chat_private',
                    'SET'		=> 'read_at='.time(),
					'WHERE'     => 'from_id=\''.$forum_db->escape($private_chat_user).'\' AND to_id=\''.$forum_db->escape($forum_user['id']).'\' AND read_at=0'
	            );
	            $forum_db->query_build($read_messages) or error(__FILE__, __LINE__);

				$query = array(
		            'SELECT'	=> 'c.*, u.id AS u_id, u.username, u.avatar, u.avatar_width, u.avatar_height, u.live_chat, a.file_name, a.file_url',
		            'FROM'		=> 'live_chat_private AS c',
		            'JOINS'		=> array(
			            array(
				            'LEFT JOIN'		=> 'users AS u',
				            'ON'		    => 'u.id=c.from_id',
			            ),
						array(
				            'LEFT JOIN'		=> 'live_chat_attachments AS a',
				            'ON'		    => 'a.msg_id=c.id AND a.chat_type=2',
			            )
		            ),
		            'WHERE'		=> '(c.to_id = '.$forum_user['id'].' AND c.from_id = '.$private_chat_user.' AND c.deleted_by_receiver != 1) OR (c.to_id = '.$private_chat_user.' AND c.from_id = '.$forum_user['id'].' AND c.deleted_by_sender != 1)',
					'ORDER BY'	=> 'send DESC'
	            );

                $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
				
				if ($u_status != 4) {
				    if (isset($_SESSION['chat_admin_func']) && $_SESSION['chat_admin_func'] != '') {
			            $admin_func = $_SESSION['chat_admin_func'];
				    } else {
					    $admin_func = 'none';
						
			        }
			        $admin_button = 1;
			    } else  { 
				    $admin_func = 'none';
				    $admin_button = 0; 
			    }
	
	            if ($forum_db->num_rows($result) > 0) {

                    $s_data = array();
                        while ($array = $forum_db->fetch_assoc($result)) {
						    $u_array = unserialize($array['live_chat']);

							$message = $array['message'];
						    if ($forum_config['p_message_bbcode'] == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false) {
				                $message = parse_bbcode($message);
				            }

				            $message = preg_replace('/\[\s*img.*\][^[]*\[\s*\/img.*\]|\[[^\]]+\]|\[\s*quote.*\][^[]*\[\s*\/quote.*\]|\[[^\]]+\]/i', '', $message);
				
				            if ($forum_config['o_make_links'] == '1') {
				                $message = parse_links($message);
				            }

	                        if ($forum_config['o_smilies'] == '1') {
					            $message = parse_smilies($message);
	                        }

	                        if ($array['u_id'] == $forum_user['id']) { $msg_class = 'my'; } else { $msg_class = ''; }
							
							if ($array['to_id'] == $forum_user['id']) {
								$msg_date = get_adjusted_date($array['send']);
							} else {
								if ($array['read_at'] > 0) {
									$msg_date = $lang_live_chat['Read'].': '.get_adjusted_date($array['read_at']);
								} elseif ($array['delivered'] > 0) {
									$msg_date = $lang_live_chat['Delivered'].': '.get_adjusted_date($array['delivered']);
								} else {
									$msg_date = $lang_live_chat['Sent'].': '.get_adjusted_date($array['send']);
								}
							}
							
						    $no_avatar = '<img src="'.$base_url.'/extensions/live_chat/css/no_avatar.jpg" alt="No avatar">';
		                    if ($forum_config['o_avatars'] == '1' && $forum_user['show_avatars'] != '0') {
			                    $u_avatar = generate_avatar_markup($array['u_id'], $array['avatar'], $array['avatar_width'], $array['avatar_height'], $array['username']);
			                    if (!empty($u_avatar)) { $user_avatar = $u_avatar; } else { $user_avatar = $no_avatar; }
		                    } else {
				                $user_avatar = $no_avatar;
			                }
							
							if (is_banned($array['username'])) { 
						        $status = 'banned'; $s_title = $lang_live_chat['Banned']; 
						    } elseif ($u_array['status'] == 4) { 
						        $status = 'silent'; $s_title = $lang_live_chat['Silent']; 
						    } elseif ($u_array['status'] == 3) { 
						        $status = 'not-disturb'; $s_title = $lang_live_chat['Do not disturb'];
						    } elseif ($u_array['status'] == 2) { 
						        $status = 'offline'; $s_title = $lang_live_chat['Offline'];
						    } elseif ($u_array['status'] == 1) { 
						        if (is_online($array['u_id'])) { 
						            $status = 'online'; $s_title = $lang_live_chat['Online']; 
						        } else { 
						            $status = 'offline'; $s_title = $lang_live_chat['Offline'];
					            }
						    }

						    $user_link = '<a class="user" title="'.sprintf($lang_profile['Users profile'], forum_htmlencode($array['username'])).'" href="'.forum_link($forum_url['user'], $array['u_id']).'" target="_blank">'.$user_avatar.'<i class="user-status user-status-'.$status.'" title="'.$s_title.'"></i></a>';
							if ($message == 'attach_image') { $msg_txt = '<div class="text_img"><a class="fancybox" rel="group" href="'.$base_url.'/'.$array['file_url'].'" target="_blank"><img style="max-height:'.$img_height.'px;" alt="'.$array['file_name'].'" src="'.$base_url.'/'.$array['file_url'].'" /></a></div>'; } else { $msg_txt = '<div class="text_msg edit_chat_msg_'.$array['id'].'">'.$message.'</div>'; }
//							if ($message == 'attach_image') { $msg_txt = '<div class="text_img"><img style="max-height:'.$img_height.'px;" alt="'.$array['file_name'].'" src="'.$base_url.'/'.$array['file_url'].'" /></img></div>'; } else { $msg_txt = '<div class="text_msg edit_chat_msg_'.$array['id'].'">'.$message.'</div>'; }
							if ($u_status != 4) { $delete_link = '<a class="msg_delete" href="#" title="'.$lang_live_chat['Delete message'].'" onclick="Delete_private_message('.$array['id'].'); return false;"></a>'; } else { $delete_link = ''; }
			                if ($array['from_id'] == $forum_user['id'] && $array['read_at'] == 0 && $message != 'attach_image') { $edit_link = '<a class="msg_edit" href="#" title="'.$lang_live_chat['Edit message'].'" onclick="Edit_message('.$array['id'].'); return false;"></a>'; } else { $edit_link = ''; }

	                        $s_data[] = '<div class="chat_message c_msg_'.$array['id'].' '.$msg_class.'">'.$user_link.'<div class="body_msg"><div class="header_msg"><span class="author" style="color:'.$u_array['user_color'].';">'.$array['username'].'</span><span class="date">'.$msg_date.'</span></div>'.$msg_txt.'<div class="footer_msg" style="display:'.$admin_func.';">&nbsp;<span class="moderate_block">'.$delete_link . $edit_link.'</span></div></div></div>';
	                    }

				    if ($i_messages == '1') {
				        $res = implode('', $s_data);
				    } else {
						$res = implode('', array_reverse($s_data));
				    }

                    echo json_encode(array('answer'=>'success','head_desc'=>$head_desc,'box_count'=>$box_count,'show_form'=>1,'upload_button'=>1,'admin_button'=>$admin_button,'content'=>$res,'public_last_entry'=>$public_last_entry,'private_last_entry'=>$private_last_entry,'public_notify'=>$new_public_msg_count,'private_notify'=>$new_private_msg_count,'user_status'=>$u_status));
				
                    die;
	            } else {
	                echo json_encode(array('answer'=>'success','head_desc'=>$head_desc,'box_count'=>$box_count,'show_form'=>1,'upload_button'=>1,'admin_button'=>$admin_button,'content'=>'<div>'.$lang_live_chat['Empty'].'</div>','public_last_entry'=>$public_last_entry,'private_last_entry'=>$private_last_entry,'public_notify'=>$new_public_msg_count,'private_notify'=>$new_private_msg_count,'user_status'=>$u_status));
				
                    die;
	            }
			} else {
				$query = array(
		            'SELECT'	=> 'c.*, MAX(c.send) AS max_send, u.id AS u_id, u.username, u.title, u.num_posts, u.avatar, u.avatar_width, u.avatar_height, u.live_chat, g.g_id, g.g_user_title',
		            'FROM'		=> 'live_chat_private AS c',
		            'JOINS'		=> array(
			            array(
				            'LEFT JOIN'		=> 'users AS u',
				            'ON'		    => 'u.id=c.from_id OR u.id=c.to_id',
			            ),
					    array(
				            'INNER JOIN'	=> 'groups AS g',
				            'ON'			=> 'g.g_id=u.group_id',
			            ),
		            ),
		            'WHERE'		=> '((c.from_id = '.$forum_user['id'].' AND c.deleted_by_sender != 1) OR (c.to_id = '.$forum_user['id'].' AND c.deleted_by_receiver != 1)) AND u.id != '.$forum_user['id'],
		            'GROUP BY'	=> 'u.id',
	                'ORDER BY'	=> 'MAX(send) DESC'
	            );
				
				($hook = get_hook('live_chat_private_qr_get_messages')) ? eval($hook) : null;

                $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	            if ($forum_db->num_rows($result) > 0) {
				    $num_rows = $forum_db->num_rows($result);
				    $counter = 0;
                    $s_data = array();
                        while ($array = $forum_db->fetch_assoc($result)) {
						    $u_array = unserialize($array['live_chat']);
							$new_msg_from_receiver = get_new_private_messages_count($array['u_id']);
							
							$no_avatar = '<img src="'.$base_url.'/extensions/live_chat/css/no_avatar.jpg" alt="No avatar">';
		                    if ($forum_config['o_avatars'] == '1' && $forum_user['show_avatars'] != '0') {
			                    $u_avatar = generate_avatar_markup($array['u_id'], $array['avatar'], $array['avatar_width'], $array['avatar_height'], $array['username']);
			                    if (!empty($u_avatar)) { $user_avatar = $u_avatar; } else { $user_avatar = $no_avatar; }
		                    } else {
				                $user_avatar = $no_avatar;
			                }
							
							if (is_banned($array['username'])) { 
						        $status = 'banned'; $s_title = $lang_live_chat['Banned']; 
						    } elseif ($u_array['status'] == 4) { 
						        $status = 'silent'; $s_title = $lang_live_chat['Silent']; 
						    } elseif ($u_array['status'] == 3) { 
						        $status = 'not-disturb'; $s_title = $lang_live_chat['Do not disturb'];
						    } elseif ($u_array['status'] == 2) { 
						        $status = 'offline'; $s_title = $lang_live_chat['Offline'];
						    } elseif ($u_array['status'] == 1) { 
						        if (is_online($array['u_id'])) { 
						            $status = 'online'; $s_title = $lang_live_chat['Online']; 
						        } else { 
						            $status = 'offline'; $s_title = $lang_live_chat['Offline'];
					            }
						    }
							
							if ($counter == ($num_rows - 1)) { $style = 'style="border-bottom:unset;"'; } else { $style = ''; }
							if ($new_msg_from_receiver > 0) { $v_notify = '<span class="chat-notify note-chat-private">'.$new_msg_from_receiver.'</span>'; } else { $v_notify = ''; }
							if (isset($black_list) && in_array($array['u_id'], $black_list)) { $i_status = $lang_live_chat['Ignored']; } else { $i_status = ''; }
						    $user_link = '<a class="user" title="'.sprintf($lang_profile['Users profile'], forum_htmlencode($array['username'])).'" href="'.forum_link($forum_url['user'], $array['u_id']).'" target="_blank">'.$user_avatar.'</a>';
			
	                        $s_data[] = '<div class="chat_userlist" '.$style.'>'.$user_link.'<div class="body_msg" onclick="Private_chat('.$array['u_id'].');"><div class="header_msg"><span class="author sel_author" style="color:'.$u_array['user_color'].';">'.$array['username'].'</span>'.$v_notify.'<span class="date"><i class="user-status user-status-'.$status.'" title="'.$s_title.'"></i>'.$s_title.' '.$i_status.'</span></div><div class="footer_msg"><span>'.get_title($array).'</span><span class="cur_date">'.$lang_live_chat['Last message'].' <strong>' .get_adjusted_date($array['max_send']).'</strong></span></div></div></div>';
	                    
						$counter++;
						}

					$res = implode('', $s_data);
					$head_desc = '<span class="desc_left">'.$lang_live_chat['List of open chats'].'</span><span class="desc_right">'.$lang_live_chat['Chats'].' ('.count($s_data).')</span>';

                    echo json_encode(array('answer'=>'success','head_desc'=>$head_desc,'box_count'=>$box_count,'show_form'=>0,'upload_button'=>0,'admin_button'=>0,'content'=>$res,'public_last_entry'=>$public_last_entry,'private_last_entry'=>$private_last_entry,'public_notify'=>$new_public_msg_count,'private_notify'=>$new_private_msg_count,'user_status'=>$u_status));
				
                    die;
	            } else {
					$head_desc = '<span class="desc_left">'.$lang_live_chat['List of open chats'].'</span><span class="desc_right">'.$lang_live_chat['Chats'].' (0)</span>';

	                echo json_encode(array('answer'=>'success','head_desc'=>$head_desc,'box_count'=>$box_count,'show_form'=>0,'upload_button'=>0,'admin_button'=>0,'content'=>'<div>'.$lang_live_chat['Empty'].'</div>','public_last_entry'=>$public_last_entry,'private_last_entry'=>$private_last_entry,'public_notify'=>$new_public_msg_count,'private_notify'=>$new_private_msg_count,'user_status'=>$u_status));
				
                    die;
	            }
			}
		} elseif ($tab == 3 && !$forum_user['is_guest']) {
			$query = array(
		        'SELECT'	=> 'u.id, u.username, u.title, u.num_posts, u.last_visit, u.avatar, u.avatar_width, u.avatar_height, u.live_chat, g.g_id, g.g_user_title',
		        'FROM'		=> 'users AS u',
		        'JOINS'		=> array(
			        array(
				        'INNER JOIN'	=> 'groups AS g',
				        'ON'			=> 'g.g_id=u.group_id'
			        ),
		        ),
				'WHERE'		=> 'u.id != '.$forum_user['id'].' AND u.id != 1',
		        'ORDER BY'	=> 'username ASC'
	        );
			
			($hook = get_hook('live_chat_private_qr_get_users')) ? eval($hook) : null;

            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	        if ($forum_db->num_rows($result) > 0) {
				$num_rows = $forum_db->num_rows($result);
				$counter = 0;
                $s_data = array();
                    while ($array = $forum_db->fetch_assoc($result)) {
						$u_array = unserialize($array['live_chat']);
						
                            $no_avatar = '<img src="'.$base_url.'/extensions/live_chat/css/no_avatar.jpg" alt="No avatar">';
		                    if ($forum_config['o_avatars'] == '1' && $forum_user['show_avatars'] != '0') {
			                    $u_avatar = generate_avatar_markup($array['id'], $array['avatar'], $array['avatar_width'], $array['avatar_height'], $array['username']);
			                    if (!empty($u_avatar)) { $user_avatar = $u_avatar; } else { $user_avatar = $no_avatar; }
		                    } else {
				                $user_avatar = $no_avatar;
			                }
							
							if (is_banned($array['username'])) { 
						        $status = 'banned'; $s_title = $lang_live_chat['Banned']; 
						    } elseif ($u_array['status'] == 4) { 
						        $status = 'silent'; $s_title = $lang_live_chat['Silent']; 
						    } elseif ($u_array['status'] == 3) { 
						        $status = 'not-disturb'; $s_title = $lang_live_chat['Do not disturb'];
						    } elseif ($u_array['status'] == 2) { 
						        $status = 'offline'; $s_title = $lang_live_chat['Offline'];
						    } elseif ($u_array['status'] == 1) { 
						        if (is_online($array['id'])) { 
						            $status = 'online'; $s_title = $lang_live_chat['Online']; 
						        } else { 
						            $status = 'offline'; $s_title = $lang_live_chat['Offline'];
					            }
						    }

							if ($counter == ($num_rows - 1)) { $style = 'style="border-bottom:unset;"'; } else { $style = ''; }
							if (isset($black_list) && in_array($array['id'], $black_list)) { $i_status = $lang_live_chat['Ignored']; } else { $i_status = ''; }
						    $user_link = '<a class="user" title="'.sprintf($lang_profile['Users profile'], forum_htmlencode($array['username'])).'" href="'.forum_link($forum_url['user'], $array['id']).'" target="_blank">'.$user_avatar.'</a>';

	                        $s_data[] = '<div class="chat_userlist" '.$style.'>'.$user_link.'<div class="body_msg" onclick="Private_chat('.$array['id'].');"><div class="header_msg"><span class="author sel_author" style="color:'.$u_array['user_color'].';">'.$array['username'].'</span><span class="date"><i class="user-status user-status-'.$status.'" title="'.$s_title.'"></i>'.$s_title.' '.$i_status.'</span></div><div class="footer_msg"><span>'.get_title($array).'</span><span class="cur_date">'.$lang_live_chat['Last visit'].' <strong>' .get_adjusted_date($array['last_visit']).'</strong></span></div></div></div>';
	                
					$counter++;
					}

				$res = implode('', $s_data);
				$head_desc = '<span class="desc_left">'.$lang_live_chat['User list'].'</span><span class="desc_right">'.$lang_live_chat['Users'].' ('.count($s_data).')</span>';

                echo json_encode(array('answer'=>'success','head_desc'=>$head_desc,'box_count'=>0,'show_form'=>0,'upload_button'=>0,'admin_button'=>0,'content'=>$res,'public_last_entry'=>$public_last_entry,'private_last_entry'=>$private_last_entry,'public_notify'=>$new_public_msg_count,'private_notify'=>$new_private_msg_count,'user_status'=>$u_status));
				
                die;
	        }
		} elseif ($tab == 4 && !$forum_user['is_guest']) {

			$v_notification = (!isset($chat_config['visual_notification']) || $chat_config['visual_notification'] == '1') ? 'checked="checked"' : '';
			$p_notification = (!isset($chat_config['popup_notification']) || $chat_config['popup_notification'] == '1') ? 'checked="checked"' : '';
			$u_profiles = (!isset($chat_config['user_profiles']) || $chat_config['user_profiles'] == '1') ? 'checked="checked"' : '';
			$i_messages = (!isset($chat_config['inversion_messages']) || $chat_config['inversion_messages'] == '1') ? 'checked="checked"' : '';
			$s_color = (!isset($chat_config['separate_color']) || $chat_config['separate_color'] == '1') ? 'checked="checked"' : '';
			$s_collapsed = (!isset($chat_config['start_collapsed']) || $chat_config['start_collapsed'] == '1') ? 'checked="checked"' : '';
			
		    $res = '<form method="post" action="" id="chat_settings_form">
			        <div class="sf-set set">
		               <div class="sf-box checkbox">
			               <span class="fld-input"><input type="checkbox" id="visual_notification" name="visual_notification" value="1" '.$v_notification.'></span>
			               <label for="fld"><span>'.$lang_live_chat['Visual notification'].'</span>'.$lang_live_chat['Visual notification info'].'</label>
		               </div>
	                </div>
					<div class="sf-set set">
		               <div class="sf-box checkbox">
			               <span class="fld-input"><input type="checkbox" id="popup_notification" name="popup_notification" value="1" '.$p_notification.'></span>
			               <label for="fld"><span>'.$lang_live_chat['Popup notification'].'</span>'.$lang_live_chat['Popup notification info'].'</label>
		               </div>
	                </div>
					<div class="sf-set set">
		               <div class="sf-box checkbox">
			               <span class="fld-input"><input type="checkbox" id="user_profiles" name="user_profiles" value="1" '.$u_profiles.'></span>
			               <label for="fld"><span>'.$lang_live_chat['User profiles'].'</span>'.$lang_live_chat['User profiles info'].'</label>
		               </div>
	                </div>
					<div class="sf-set set">
		               <div class="sf-box checkbox">
			               <span class="fld-input"><input type="checkbox" id="inversion_messages" name="inversion_messages" value="1" '.$i_messages.'></span>
			               <label for="fld"><span>'.$lang_live_chat['Inversion messages'].'</span>'.$lang_live_chat['Inversion messages info'].'</label>
		               </div>
	                </div>
					<div class="sf-set set">
		               <div class="sf-box checkbox">
			               <span class="fld-input"><input type="checkbox" id="separate_color" name="separate_color" value="1" '.$s_color.'></span>
			               <label for="fld"><span>'.$lang_live_chat['Separate color messaging'].'</span>'.$lang_live_chat['Separate color messaging info'].'</label>
		               </div>
	                </div>
					<div class="sf-set set">
		               <div class="sf-box checkbox">
			               <span class="fld-input"><input type="checkbox" id="start_collapsed" name="start_collapsed" value="1" '.$s_collapsed.'></span>
			               <label for="fld"><span>'.$lang_live_chat['Start collapsed'].'</span>'.$lang_live_chat['Start collapsed info'].'</label>
		               </div>
	                </div>
					<div class="frm-buttons">
				        <span class="submit primary"><input value="'.$lang_live_chat['Save'].'" type="button" onclick="SaveChatSettings()" /></span>
			        </div>
                    </form>';

			echo json_encode(array('answer'=>'success','head_desc'=>0,'box_count'=>0,'show_form'=>0,'upload_button'=>0,'admin_button'=>0,'content'=>$res,'public_last_entry'=>$public_last_entry,'private_last_entry'=>$private_last_entry,'public_notify'=>$new_public_msg_count,'private_notify'=>$new_private_msg_count,'user_status'=>$u_status));
				
            die;
		} else {
	        echo json_encode(array('answer'=>'limited','content'=>'<div>'.$lang_live_chat['Message for unregistered users'].'</div>'));
				
            die;
        }
    }
}

else if ($action == 'user_data')
{
	$msg_id = isset($_GET['msg_id']) ? intval($_GET['msg_id']) : 0;
	$status = isset($_GET['u_status']) ? $_GET['u_status'] : null;
	
	if ($msg_id > 0) {
        $query = array(
			'SELECT'	=> 'c.user_id, c.author, u.username, u.title, u.num_posts, u.avatar, u.avatar_width, u.avatar_height, g.g_id, g.g_user_title',
			'FROM'		=> 'live_chat AS c',
		    'JOINS'		=> array(
			    array(
				    'INNER JOIN'	=> 'users AS u',
				    'ON'			=> 'u.id=c.user_id'
			    ),
			    array(
				    'INNER JOIN'	=> 'groups AS g',
				    'ON'			=> 'g.g_id=u.group_id'
			    ),
		    ),
            'WHERE'		=> 'c.id='.$msg_id
		);
		
		($hook = get_hook('live_chat_qr_get_user_data')) ? eval($hook) : null;
		
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $user = $forum_db->fetch_assoc($result);
		
		$no_avatar = '<img src="'.$base_url.'/extensions/live_chat/css/no_avatar.jpg" alt="No avatar" width="130" height="130">';
		
		if ($user['user_id'] > 1) {
		    $username = (($forum_user['g_view_users'] == '1') ? '<a title="'.sprintf($lang_profile['Users profile'], forum_htmlencode($user['author'])).'" href="'.forum_link($forum_url['user'], $user['user_id']).'">'.forum_htmlencode($user['author']).'</a>' : '<strong>'.forum_htmlencode($user['author']).'</strong>');
		
		    if ($forum_config['o_avatars'] == '1' && $forum_user['show_avatars'] != '0')
	        {
			    $u_avatar = generate_avatar_markup($user['user_id'], $user['avatar'], $user['avatar_width'], $user['avatar_height'], $user['username']);
			    if (!empty($u_avatar)) { $user_avatar = $u_avatar; } else { $user_avatar = $no_avatar; }
		    } else {
				$user_avatar = $no_avatar;
			}
		} else {
		    $username = '<strong>'.forum_htmlencode($user['author']).'</strong>';
			$user_avatar = $no_avatar;
		}
		
		if ($status == 'online') { 
		    $s_title = $lang_live_chat['Online'];
		} elseif ($status == 'offline') { 
            $s_title = $lang_live_chat['Offline'];
        } elseif ($status == 'not-disturb') {
            $s_title = $lang_live_chat['Do not disturb'];
        } elseif ($status == 'silent') {
            $s_title = $lang_live_chat['Silent'];
        } elseif ($status == 'banned') {
            $s_title = $lang_live_chat['Banned'];
        }

        $html = '<div class="author-ident">
					<div class="p_username">'.$username.'</div>
					<div class="useravatar">'.$user_avatar.'</div>
				    <div class="usertitle"><span>'.get_title($user).'</span></div>
					<div class="userstatus" title="'.$lang_live_chat['Status'].'"><span>'.$s_title.'</span></div>
				</div><div class="c_arrow"></div>';
        echo $html;
    }
}

else if ($action == 'user_status')
{
	$status = isset($_GET['u_status']) ? $_GET['u_status'] : null;
	
	if  ($status != null && !$forum_user['is_guest'] && $chat_config['status'] != 4) {
		
		if ($status == 3 && $chat_config['sound_notification'] == 1) {
			$sound = 0;
		} else if ($status != 3 && $chat_config['sound_notification'] == 0) {
			$sound = 1;
		}
		
		$conf = array();
        $conf['user_color'] = $chat_config['user_color'];
        $conf['sound_notification'] = isset($sound) ? $sound : $chat_config['sound_notification'];
        $conf['visual_notification'] = $chat_config['visual_notification'];
	    $conf['popup_notification'] = $chat_config['popup_notification'];
		$conf['user_profiles'] = $chat_config['user_profiles'];
        $conf['inversion_messages'] = $chat_config['inversion_messages'];
		$conf['separate_color'] = $chat_config['separate_color'];
        $conf['start_collapsed'] = $chat_config['start_collapsed'];
	    $conf['status'] = $status;
		
		$query = array(
		    'UPDATE'		=> 'users',
		    'SET'           => 'live_chat =\''.$forum_db->escape(serialize($conf)).'\'',
	        'WHERE'			=> 'id = '.$forum_user['id']
	    );
	    $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		echo isset($sound) ? $sound : 2;
    }
}

else if ($action == 'user_color')
{
	$color = isset($_GET['color']) ? $_GET['color'] : null;
	
	if  ($color != null && !$forum_user['is_guest']) {
         update_settings('user_color', $color);
    }
}

else if ($action == 'sound_notification')
{
	if (!$forum_user['is_guest'] && $chat_config['status'] != 3) {
        if ($chat_config['sound_notification'] == 0) { $sound = 1; } else { $sound = 0; }
		
	    update_settings('sound_notification', $sound);

	    echo $sound;
	} else {
		echo 2;
	}
}

else if ($action == 'admin_functions')
{
    $func = isset($_GET['func']) ? $_GET['func'] : null;

	if  ($func != null && !$forum_user['is_guest']) {
        $_SESSION['chat_admin_func'] = $func;
    }
}

else if ($action == 'delete_msg')
{
	$msg_id = isset($_GET['msg_id']) ? intval($_GET['msg_id']) : 0;
	
	if ($msg_id > 0 && ($forum_user['is_admmod'] OR $forum_user['g_moderator'] == '1')) {
		$query = array(
    	    'SELECT'	=> 'id, message',
    	    'FROM'		=> 'live_chat',
			'WHERE'		=> 'id=\''.$forum_db->escape($msg_id).'\'',
		    'LIMIT'	    => 1
        );
        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $msg = $forum_db->fetch_assoc($result);
		
		if ($msg['message'] == 'attach_image') {
			$query = array(
    	        'SELECT'	=> 'file_url',
    	        'FROM'		=> 'live_chat_attachments',
			    'WHERE'	    => 'msg_id = '.$msg_id.' AND chat_type = 1',
		        'LIMIT'	    => 1
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$attach = $forum_db->fetch_assoc($result);
			
			unlink(FORUM_ROOT.$attach['file_url']);
			
			$query = array(
		        'DELETE'	=> 'live_chat_attachments',
		        'WHERE'	    => 'msg_id = '.$msg_id.' AND chat_type = 1',
	        );
	        $forum_db->query_build($query) or error(__FILE__, __LINE__);	
		}

		$query = array(
            'DELETE'	=> 'live_chat',
			'WHERE'		=> 'id=\''.$forum_db->escape($msg_id).'\''
	    );
	    $forum_db->query_build($query) or error(__FILE__, __LINE__);
    }
}

else if ($action == 'delete_private_msg')
{
	$msg_id = isset($_GET['msg_id']) ? intval($_GET['msg_id']) : 0;
	$user_id = isset($_GET['user_id']) ? intval($_GET['user_id']) : 0;
	
	if ($msg_id > 0 && !$forum_user['is_guest']) {
		$query = array(
    	   'SELECT'	    => 'id, from_id, to_id, message, delivered, deleted_by_sender, deleted_by_receiver',
    	   'FROM'		=> 'live_chat_private',
		   'WHERE'		=> 'id=\''.$forum_db->escape($msg_id).'\'',
		   'LIMIT'	    => 1
        );
        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $del_msg = $forum_db->fetch_assoc($result);
		
		if ($del_msg['from_id'] == $forum_user['id']) {
			if ($del_msg['delivered'] == 0 || $del_msg['deleted_by_receiver'] == 1) {
//	        if ($del_msg['deleted_by_receiver'] == 1) {
                if ($del_msg['message'] == 'attach_image') {
			        $query = array(
    	                'SELECT'	=> 'file_url',
    	                'FROM'		=> 'live_chat_attachments',
			            'WHERE'	    => 'msg_id = '.$msg_id.' AND chat_type = 2',
		                'LIMIT'	    => 1
                    );
                    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			        $attach = $forum_db->fetch_assoc($result);
			
			        unlink(FORUM_ROOT.$attach['file_url']);
			
			        $query = array(
		                'DELETE'	=> 'live_chat_attachments',
		                'WHERE'	    => 'msg_id = '.$msg_id.' AND chat_type = 2',
	                );
	                $forum_db->query_build($query) or error(__FILE__, __LINE__);	
		        }

				$query = array(
                    'DELETE'	=> 'live_chat_private',
			        'WHERE'		=> 'id=\''.$forum_db->escape($msg_id).'\''
	            );
	            $forum_db->query_build($query) or error(__FILE__, __LINE__);
			} else {
				$query = array(
		            'UPDATE'	=> 'live_chat_private',
		            'SET'       => 'deleted_by_sender = 1',
	                'WHERE'		=> 'id=\''.$forum_db->escape($msg_id).'\''
	            );
	            $forum_db->query_build($query) or error(__FILE__, __LINE__);	
			}
        } else {
			if ($del_msg['deleted_by_sender'] == 1) {
				if ($del_msg['message'] == 'attach_image') {
			        $query = array(
    	                'SELECT'	=> 'file_url',
    	                'FROM'		=> 'live_chat_attachments',
			            'WHERE'	    => 'msg_id = '.$msg_id.' AND chat_type = 2',
		                'LIMIT'	    => 1
                    );
                    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			        $attach = $forum_db->fetch_assoc($result);
			
			        unlink(FORUM_ROOT.$attach['file_url']);
			
			        $query = array(
		                'DELETE'	=> 'live_chat_attachments',
		                'WHERE'	    => 'msg_id = '.$msg_id.' AND chat_type = 2',
	                );
	                $forum_db->query_build($query) or error(__FILE__, __LINE__);	
		        }

				$query = array(
                    'DELETE'	=> 'live_chat_private',
			        'WHERE'		=> 'id=\''.$forum_db->escape($msg_id).'\''
	            );
	            $forum_db->query_build($query) or error(__FILE__, __LINE__);
			} else {
				$query = array(
		            'UPDATE'	=> 'live_chat_private',
		            'SET'       => 'deleted_by_receiver = 1',
	                'WHERE'		=> 'id=\''.$forum_db->escape($msg_id).'\''
	            );
	            $forum_db->query_build($query) or error(__FILE__, __LINE__);	
			}
		}
	} elseif ($msg_id == 0 && !$forum_user['is_guest'] && isset($user_id) && $user_id > 1) {
		$private_chat_user = $user_id;

		$query = array(
		    'SELECT'	=> 'c.*, a.file_url',
		    'FROM'		=> 'live_chat_private AS c',
			'JOINS'		=> array(
				array(
				    'LEFT JOIN'	=> 'live_chat_attachments AS a',
				    'ON'		=> 'a.msg_id=c.id AND a.chat_type=2',
			    )
		    ),
		    'WHERE'		=> '(c.to_id = '.$forum_user['id'].' AND c.from_id = '.$private_chat_user.') OR (c.to_id = '.$private_chat_user.' AND c.from_id = '.$forum_user['id'].')',
	    );
        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		if ($forum_db->num_rows($result) > 0) {
            while ($del_msg = $forum_db->fetch_assoc($result)) {
		        if ($del_msg['from_id'] == $forum_user['id']) {
			        if ($del_msg['delivered'] == 0 || $del_msg['deleted_by_receiver'] == 1) {
//					if ($del_msg['deleted_by_receiver'] == 1) {
	                    if ($del_msg['message'] == 'attach_image') {
			                unlink(FORUM_ROOT.$del_msg['file_url']);
			
			                $query = array(
		                        'DELETE'	=> 'live_chat_attachments',
		                        'WHERE'	    => 'msg_id = '.$del_msg['id'].' AND chat_type = 2',
	                        );
	                        $forum_db->query_build($query) or error(__FILE__, __LINE__);	
		                }

				        $query = array(
                            'DELETE'	=> 'live_chat_private',
			                'WHERE'		=> 'id=\''.$forum_db->escape($del_msg['id']).'\''
	                    );
	                    $forum_db->query_build($query) or error(__FILE__, __LINE__);
			        } else {
				        $query = array(
		                    'UPDATE'	=> 'live_chat_private',
		                    'SET'       => 'deleted_by_sender = 1',
	                        'WHERE'		=> 'id=\''.$forum_db->escape($del_msg['id']).'\''
	                    );
	                    $forum_db->query_build($query) or error(__FILE__, __LINE__);	
			        }
                } else {
			        if ($del_msg['deleted_by_sender'] == 1) {
						if ($del_msg['message'] == 'attach_image') {
			                unlink(FORUM_ROOT.$del_msg['file_url']);
			
			                $query = array(
		                        'DELETE'	=> 'live_chat_attachments',
		                        'WHERE'	    => 'msg_id = '.$del_msg['id'].' AND chat_type = 2',
	                        );
	                        $forum_db->query_build($query) or error(__FILE__, __LINE__);	
		                }
						
				        $query = array(
                            'DELETE'	=> 'live_chat_private',
			                'WHERE'		=> 'id=\''.$forum_db->escape($del_msg['id']).'\''
	                    );
	                    $forum_db->query_build($query) or error(__FILE__, __LINE__);
			        } else {
				        $query = array(
		                    'UPDATE'	=> 'live_chat_private',
		                    'SET'       => 'deleted_by_receiver = 1',
	                        'WHERE'		=> 'id=\''.$forum_db->escape($del_msg['id']).'\''
	                    );
	                    $forum_db->query_build($query) or error(__FILE__, __LINE__);	
			        }
		        }
            }
        }		
    }
}

else if ($action == 'silent')
{
	$user_id = isset($_GET['user_id']) ? intval($_GET['user_id']) : 0;
	
	if (($forum_user['is_admmod'] OR $forum_user['g_moderator'] == '1') && $user_id > 1 && $user_id != $forum_user['id']) {
		
		$query = array(
    	    'SELECT'	=> 'live_chat',
		    'FROM'		=> 'users',
		    'WHERE'		=> 'id='.$user_id
        );
        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$r_result = $forum_db->fetch_assoc($result);
		$silent_status = unserialize($r_result['live_chat']);

		if ($silent_status['status'] == 4) { $status = 1; } else { $status = 4; }
		
		update_settings('status', $status, $user_id);
		
		echo $status;
    }
}

else if ($action == 'ban')
{
	$msg_id = isset($_GET['msg_id']) ? intval($_GET['msg_id']) : 0;
	
	if ($msg_id > 0 && $forum_user['is_admmod']) {
		
		$query = array(
    	    'SELECT'	=> '*',
		    'FROM'		=> 'live_chat',
		    'WHERE'		=> 'id='.$msg_id
        );
        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$ban = $forum_db->fetch_assoc($result);
		
		if ($ban['user_id'] != $forum_user['id']) {
		    if (is_banned($ban['author'], $ban['user_ip'])) {
				if ($ban['user_id'] > 1) {
					$query = array(
			           'SELECT'	    => 'email',
			           'FROM'		=> 'users',
                       'WHERE'		=> 'id='.$ban['user_id']
		            );
		            $res = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	                $banned_user = $forum_db->fetch_assoc($res);
					
					$query = array(
		                'DELETE'	=> 'bans',
						'WHERE'		=> 'email=\''.$forum_db->escape($banned_user['email']).'\''
	                );
					$forum_db->query_build($query) or error(__FILE__, __LINE__);
				} else {
					$query = array(
		                'DELETE'	=> 'bans',
						'WHERE'		=> 'ip=\''.$forum_db->escape($ban['user_ip']).'\''
	                );
					$forum_db->query_build($query) or error(__FILE__, __LINE__);
				}
				
				$status = 0;
			} else {
				if ($ban['user_id'] > 1) {
					$query = array(
			           'SELECT'	    => 'email',
			           'FROM'		=> 'users',
                       'WHERE'		=> 'id='.$ban['user_id']
		            );
		            $res = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	                $banned_user = $forum_db->fetch_assoc($res);
					
					$query = array(
			            'INSERT'	=> 'username, ip, email, message, expire, ban_creator',
			            'INTO'		=> 'bans',
						'VALUES'	=> '\''.$forum_db->escape($ban['author']).'\', NULL, \''.$forum_db->escape($banned_user['email']).'\', NULL, NULL, '.$forum_user['id']
		            );
		            $forum_db->query_build($query) or error(__FILE__, __LINE__);
				} else {
					$query = array(
			            'INSERT'	=> 'username, ip, email, message, expire, ban_creator',
			            'INTO'		=> 'bans',
						'VALUES'	=> '\''.$forum_db->escape($ban['author']).'\', \''.$forum_db->escape($ban['user_ip']).'\', NULL, NULL, NULL, '.$forum_user['id']
		            );
		            $forum_db->query_build($query) or error(__FILE__, __LINE__);
				}
				
				$status = 1;
			}

		    if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
		        require FORUM_ROOT.'include/cache.php';

	        generate_bans_cache();
		}

		echo $status;
    }
}

else if ($action == 'admin_silent')
{
	$user_id = isset($_GET['id']) ? intval($_GET['id']) : 0;
	
	if (($forum_user['is_admmod'] OR $forum_user['g_moderator'] == '1') && $user_id > 1 && $user_id != $forum_user['id']) {
		
		$query = array(
    	    'SELECT'	=> 'live_chat',
		    'FROM'		=> 'users',
		    'WHERE'		=> 'id='.$user_id
        );
        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$r_result = $forum_db->fetch_assoc($result);
		$silent_status = unserialize($r_result['live_chat']);

		if ($silent_status['status'] == 4) { $status = 1; $message = $lang_live_chat['Silent mode disabled']; } else { $status = 4; $message = $lang_live_chat['Silent mode enabled']; }
		
		update_settings('status', $status, $user_id);

		$forum_flash->add_info($message);
		redirect(forum_link($forum_url['profile_admin'], $user_id), $message);
    }
}

else if ($action == 'save_settings')
{
    if (count($_POST) > 0 && !$forum_user['is_guest']) {

		$conf = array();
	    $conf['user_color'] = $chat_config['user_color'];
		$conf['sound_notification'] = $chat_config['sound_notification'];
		$conf['visual_notification'] = (!isset($_POST['visual_notification']) || $_POST['visual_notification'] != '1') ? '0' : '1';
	    $conf['popup_notification'] = (!isset($_POST['popup_notification']) || $_POST['popup_notification'] != '1') ? '0' : '1';
		$conf['user_profiles'] = (!isset($_POST['user_profiles']) || $_POST['user_profiles'] != '1') ? '0' : '1';
	    $conf['inversion_messages'] = (!isset($_POST['inversion_messages']) || $_POST['inversion_messages'] != '1') ? '0' : '1';
		$conf['separate_color'] = (!isset($_POST['separate_color']) || $_POST['separate_color'] != '1') ? '0' : '1';
		$conf['start_collapsed'] = (!isset($_POST['start_collapsed']) || $_POST['start_collapsed'] != '1') ? '0' : '1';
		$conf['status'] = $chat_config['status'];
		
		$query = array(
		    'UPDATE'		=> 'users',
		    'SET'           => 'live_chat =\''.$forum_db->escape(serialize($conf)).'\'',
	        'WHERE'			=> 'id = '.$forum_user['id']
	    );
	    $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$public_last_entry = get_last_message();
		$private_last_entry = get_last_private_message();
		$res = '<div id="chat_settings" chat_refresh="'.$forum_config['o_live_chat_refresh_time'].'" chat_height="'.$forum_config['o_live_chat_max_height'].'" chat_sound="'.$conf['sound_notification'].'" visual_notification="'.$conf['visual_notification'].'" chat_inversion="'.$conf['inversion_messages'].'" chat_notify="'.$conf['popup_notification'].'" public_maxlength="'.$forum_config['o_live_chat_message_max_len'].'" private_maxlength="'.$forum_config['o_live_chat_private_message_max_len'].'" public_last_entry="'.$public_last_entry.'" private_last_entry="'.$private_last_entry.'">4</div>';
		
		echo json_encode(array('answer'=>'success','content'=>$res));
				
        die;
    }	
}

else if ($action == 'edit_message')
{
    $tab = isset($_GET['tab']) ? intval($_GET['tab']) : 1;
    $msg_id = isset($_GET['msg_id']) ? intval($_GET['msg_id']) : 0;
	
	if ($msg_id > 0 && !$forum_user['is_guest']) {
		if ($tab == 1) {
			$query = array(
    	       'SELECT'	    => 'message',
    	       'FROM'		=> 'live_chat',
			   'WHERE'	    => 'id = '.$msg_id,
		       'LIMIT'	    => 1
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$text = $forum_db->fetch_assoc($result);

		    echo $text['message'];
		} elseif ($tab == 2) {
			$query = array(
    	       'SELECT'	    => 'message',
    	       'FROM'		=> 'live_chat_private',
			   'WHERE'	    => 'id = '.$msg_id,
		       'LIMIT'	    => 1
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$text = $forum_db->fetch_assoc($result);

		    echo $text['message'];
		}
    }	
}

else if ($action == 'update_message')
{
    if (count($_POST) > 0 && !$forum_user['is_guest']) {
		$tab = isset($_POST['tab']) ? intval($_POST['tab']) : 1;
		$msg_id = isset($_POST['msg_id']) ? intval($_POST['msg_id']) : 0;
		$message = strip_tags($_POST['text']);
		
		if ($tab == 1 && $msg_id > 0 && $message != '' && ($forum_user['is_admmod'] OR $forum_user['g_moderator'] == '1')) {
			$query = array(
		        'UPDATE'		=> 'live_chat',
		        'SET'           => 'message =\''.$forum_db->escape($message).'\'',
	            'WHERE'			=> 'id = '.$msg_id
	        );
	        $forum_db->query_build($query) or error(__FILE__, __LINE__);
		} elseif ($tab == 2 && $msg_id > 0 && $message != '') {
			$query = array(
    	       'SELECT'	    => 'id',
    	       'FROM'		=> 'live_chat_private',
			   'WHERE'	    => 'id = '.$msg_id.' AND from_id = '.$forum_user['id'].' AND read_at = 0',
		       'LIMIT'	    => 1
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

			if ($forum_db->num_rows($result) == 1) {
			    $query = array(
		            'UPDATE'		=> 'live_chat_private',
		            'SET'           => 'message =\''.$forum_db->escape($message).'\'',
	                'WHERE'			=> 'id = '.$msg_id
	            );
	            $forum_db->query_build($query) or error(__FILE__, __LINE__);
			}
		}
    }	
}

else if ($action == 'get_pm_notifications')
{
    $cnt = get_new_private_messages_count();
    $private_last_entry = get_last_private_message();
			
	echo json_encode(array('notify'=>$cnt,'private_last_entry'=>$private_last_entry));
    die;
}

function update_settings($key, $value, $id = null) 
{
    global $forum_db, $forum_user, $chat_config;
	
	if (isset($key) && isset($value)) {
		
		$user_id = isset($id) ? intval($id) : $forum_user['id'];

	    if ($user_id == $forum_user['id']) {
			$conf = $chat_config;
		} else {
			$query = array(
    	        'SELECT'	=> 'live_chat',
		        'FROM'		=> 'users',
		        'WHERE'		=> 'id='.$user_id
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		    $r_result = $forum_db->fetch_assoc($result);
		    $u_chat_config = unserialize($r_result['live_chat']);
			
			$conf = $u_chat_config;
		}

		unset($conf[$key]);

        $new_conf  = array(); 
        foreach($conf as $k => $v) { 
            $new_conf[$k] = $v;
            $new_conf[$key] = $value;		
        }

	    $query = array(
		    'UPDATE'		=> 'users',
		    'SET'           => 'live_chat =\''.$forum_db->escape(serialize($new_conf)).'\'',
	        'WHERE'			=> 'id = '.$user_id
	    );
	    $forum_db->query_build($query) or error(__FILE__, __LINE__);
	}
}


function check_messages_period() 
{
    global $forum_db, $forum_user, $forum_config, $chat_config;

        if ($forum_user['is_admmod'])
		{
            return TRUE;
        }
		
		if (!$forum_user['is_guest']) {

		    $query = array(
    	    'SELECT'	=> 'id, date',
    	    'FROM'		=> 'live_chat',
			'WHERE'		=> 'user_id=\''.$forum_db->escape($forum_user['id']).'\'',
    	    'ORDER BY'	=> 'date DESC',
		    'LIMIT'	    => 1
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		} else {
		    $user_ip = $_SERVER['REMOTE_ADDR'];
		
		    $query = array(
    	    'SELECT'	=> 'id, date',
    	    'FROM'		=> 'live_chat',
			'WHERE'		=> 'user_ip=\''.$forum_db->escape($user_ip).'\'',
    	    'ORDER BY'	=> 'date DESC',
		    'LIMIT'	    => 1
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		}

	if ($forum_db->num_rows($result) == 1) {
	    $entry = $forum_db->fetch_assoc($result);

        $latest_entry = $entry['date'];
        $allow_time = $latest_entry + ($forum_config['o_live_chat_posted_period'] * 60);

        if ($allow_time > time()) {
            return FALSE;
        } else {
            return TRUE;
        }
    } else {
        return TRUE;
    }
}
	
function check_messages_count() 
{
    global $forum_db, $forum_config, $db_host, $db_username, $db_password, $db_name, $db_prefix;
	
		$query = array(
		    'SELECT'	=> 'count(*)',
		    'FROM'		=> 'live_chat'
	    );
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
        
        $cnt = $forum_db->result($result);
		
		if ($cnt > $forum_config['o_live_chat_auto_delete']) {
            $limit = $cnt - $forum_config['o_live_chat_auto_delete']; 

			$last_entry = get_last_message();
			
			$table_name = $db_prefix.'live_chat';
			
/*			$link = @mysql_connect($db_host, $db_username, $db_password);
			if ($link) {
			    @mysql_select_db($db_name);
                @mysql_query("DELETE FROM $table_name WHERE date < '$last_entry' ORDER BY date ASC LIMIT $limit") or die (mysql_error());
			}*/
			
			$link = @mysqli_connect($db_host, $db_username, $db_password, $db_name);
			if ($link) {
                @mysqli_query($link, "DELETE FROM $table_name WHERE date < '$last_entry' ORDER BY date ASC LIMIT $limit") or die (mysqli_error($link));
			}
        }
}

function get_last_message() 
{
    global $forum_db, $black_list;
	
	$query = array(
    	'SELECT'	=> 'date',
    	'FROM'		=> 'live_chat',
    	'ORDER BY'	=> 'date DESC',
		'LIMIT'	    => 1
    );
	
	if (isset($black_list)) {
		$query['WHERE'] = 'user_id NOT IN ('.implode(',', $black_list).')';
	}
	
    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	if ($forum_db->num_rows($result) > 0) {
	    $l_entry = $forum_db->fetch_assoc($result);
		return $l_entry['date'];
	} else {
	    return '0';
	}
}

function get_last_private_message() 
{
    global $forum_db, $forum_user, $forum_config, $black_list;
	
	if (!$forum_user['is_guest'] && $forum_config['o_live_chat_private_chat'] == '1') {
	    $query = array(
    	    'SELECT'	=> 'send',
    	    'FROM'		=> 'live_chat_private',
    	    'ORDER BY'	=> 'send DESC',
		    'LIMIT'	    => 1
        );
		
		if (isset($black_list)) { $query['WHERE'] = '(to_id = '.$forum_user['id'].' OR from_id = '.$forum_user['id'].')  AND from_id NOT IN ('.implode(',', $black_list).')'; } else { $query['WHERE'] = 'to_id = '.$forum_user['id'].' OR from_id = '.$forum_user['id']; }
		
        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	    if ($forum_db->num_rows($result) > 0) {
	        $l_entry = $forum_db->fetch_assoc($result);
		    return $l_entry['send'];
	    } else {
	        return '0';
	    }
	} else {
		return '0';
	}
}

function get_private_messages_count($param = 'my_box', $user_id = null) 
{
    global $forum_db, $forum_user;

	$query = array(
		'SELECT' => 'count(*)',
		'FROM'	 => 'live_chat_private',
	);
	
	if ($param == 'my_box') {
		$query['WHERE'] = '(from_id = '.$forum_user['id'].' AND deleted_by_sender = 0) OR (to_id = '.$forum_user['id'].' AND deleted_by_receiver = 0)';
	} elseif ($param == 'chat_box' && isset($user_id)) {
		$query['WHERE'] = '(to_id = '.$forum_user['id'].' AND from_id = '.$user_id.' AND deleted_by_receiver = 0) OR (to_id = '.$user_id.' AND from_id = '.$forum_user['id'].' AND deleted_by_sender = 0)';
	} elseif ($param == 'user_box' && isset($user_id)) {
		$query['WHERE'] = '(from_id = '.$user_id.' AND deleted_by_sender = 0) OR (to_id = '.$user_id.' AND deleted_by_receiver = 0)';
	}

	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$cnt = $forum_db->result($result);

	return $cnt;
}

function get_new_public_messages_count()
{
    global $forum_db, $forum_user, $chat_config, $black_list;
	
	if (!$forum_user['is_guest'] && $chat_config['visual_notification'] == 1) {
		$query = array(
		    'SELECT'  => 'COUNT(l.id)',
		    'FROM'	=> 'live_chat AS l',
	    );
		
		if (isset($_COOKIE['chat_public_last_notify']) && $_COOKIE['chat_public_last_notify'] > $forum_user['last_visit']) { $query['WHERE'] = 'l.date>'.$_COOKIE['chat_public_last_notify'].' AND user_id != '.$forum_user['id']; } else { $query['WHERE'] = 'l.date>'.$forum_user['last_visit'].' AND user_id != '.$forum_user['id']; }
		
		if (isset($black_list)) {
		    $query['WHERE'] .= ' AND user_id NOT IN ('.implode(',', $black_list).')';
		}

	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $public_count = $forum_db->result($result);
	
	    if ($public_count > 0) { $public_count = $public_count; } else { $public_count = 0; }

	    return $public_count;
	}

	return 0;
}

function get_new_private_messages_count($user_id = false)
{
    global $forum_db, $forum_user, $forum_config, $chat_config, $black_list;
	
	if (!$forum_user['is_guest'] && $forum_config['o_live_chat_private_chat'] == '1' && ($chat_config['visual_notification'] == 1 || $user_id != false)) {
		$query = array(
		    'SELECT' => 'count(*)',
		    'FROM'	 => 'live_chat_private',
	    );

        if ($user_id == false) { $query['WHERE'] = 'to_id = '.$forum_user['id'].' AND read_at = 0'; } else { $query['WHERE'] = 'from_id = '.$user_id.' AND to_id = '.$forum_user['id'].' AND read_at = 0'; }
		
		if (isset($black_list)) {
		    $query['WHERE'] .= ' AND from_id NOT IN ('.implode(',', $black_list).')';
		}
			
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$private_count = $forum_db->result($result);
	
	    if ($private_count > 0) { $private_count = $private_count; } else { $private_count = 0; }

	    return $private_count;
	}

	return 0;
}

function is_banned($name, $ip = null)
{
	global $forum_bans;
	
	if (isset($ip)) {
		$user_ip = $ip;
	    $user_ip .= (strpos($user_ip, '.') !== false) ? '.' : ':';
	}

	$is_banned = false;

	foreach ($forum_bans as $cur_ban)
	{
		
		if ($cur_ban['username'] != '' && mb_strtolower($name) == mb_strtolower($cur_ban['username']))
			$is_banned = true;

		if (isset($ip) && $cur_ban['ip'] != '')
		{
			$cur_ban_ips = explode(' ', $cur_ban['ip']);

			$num_ips = count($cur_ban_ips);
			for ($i = 0; $i < $num_ips; ++$i)
			{
				if (strpos($user_ip, '.') !== false)
					$cur_ban_ips[$i] = $cur_ban_ips[$i].'.';
				else
					$cur_ban_ips[$i] = $cur_ban_ips[$i].':';

				if (substr($user_ip, 0, strlen($cur_ban_ips[$i])) == $cur_ban_ips[$i])
				{
					$is_banned = true;
					break;
				}
			}
		}

		if ($is_banned)
		{
           return true; 
		}
	}

	return false;
}

function is_online($id, $ip_address = null)
{
    global $forum_db;
	
	$query  = array(
    	'SELECT' => 'ident',
		'FROM'	 => 'online'
    );
	
	if ($id > 1) { $query['WHERE'] = 'user_id=\''.$forum_db->escape($id).'\' AND idle=0'; } else { $query['WHERE'] = 'ident=\''.$forum_db->escape($ip_address).'\' AND idle=0'; }
	
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($result) > 0) {
		return TRUE;
	} else {
		return FALSE;
	}
}

function parse_bbcode($text)
{
	$bbcode = array(
		'[b]', '[/b]',
		'[i]', '[/i]',
		'[u]', '[/u]',
	);

	$html = array(
		'<b>', '</b>',
		'<i>', '</i>',
		'<u>', '</u>',
	);

	$text = str_replace($bbcode, $html, $text);

	$advanced_bbcode = array(
		'#\[color=([a-zA-Z]*|\#?[0-9a-fA-F]{6})](.+)\[/color\]#Usi',
    );

	$advanced_html = array(
		'<span style="color: $1">$2</span>',
	);

	$text = preg_replace($advanced_bbcode, $advanced_html,$text);
	$text = parse_username_tag($text);

	return $text;
}

function parse_username_tag($text)
{
	$text = preg_replace_callback('#\[user=([0-9]+?)\](.+?)\[/user\]#', 'callback_get_username', $text);

	return $text;
}

function callback_get_username($reg)
{
  return get_username($reg[1], $reg[2]);
}

function get_username($id, $name) 
{
    global $forum_db, $forum_config, $lang_live_chat;
	
	if (is_numeric($id) && $name != '')
    {
        $user_id = intval($id);
		if ($user_id > 1) {
			$query = array(
    	        'SELECT'	=> 'id, username, live_chat',
		        'FROM'		=> 'users',
		        'WHERE'		=> 'id='.$user_id,
				'LIMIT'	    => 1
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			
		    if ($forum_db->num_rows($result) == 1) {
				$user = $forum_db->fetch_assoc($result);

			    if ($forum_config['o_live_chat_change_color'] == '1') {
			        $user_data = unserialize($user['live_chat']);
					
					if ($name != 'get_real_username') {
					    return '<b>&rArr; <font color="'.$user_data['user_color'].'">'.$name.'</font></b>';
					} else {
						return '<font color="'.$user_data['user_color'].'">'.$user['username'].'</font>';
					}
                } else {
					if ($name != 'get_real_username') {
					    return '<b>&rArr; '.$name.'</b>';
					} else {
						return $user['username'];
					}
				}
            }
        } else {
			return '<b>&rArr; '.$name.' '.$lang_live_chat['Guest'].'</b>';
		}
    }      
}

function check_user($id, $username = false) 
{
    global $forum_db;
	
	if (isset($id) && is_numeric($id))
    {
        $user_id = intval($id);
		if ($user_id > 0) {
			$query = array(
    	        'SELECT'	=> 'id, username',
		        'FROM'		=> 'users',
		        'WHERE'		=> 'id='.$user_id,
				'LIMIT'	    => 1
            );
            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			
		    if ($forum_db->num_rows($result) == 1) {
				$user = $forum_db->fetch_assoc($result);

			    if ($username && $username != $user['username']) {
					return FALSE;
				}
				
				return TRUE;	
            }
        }
    } 

    return FALSE;	
}

function parse_links($text) 
{
	global $lang_live_chat;

    $text= preg_replace("/(^|[\n ])([\w]*?)(http(s)?:\/\/[\w]+[^ \,\"\n\r\t<]*)/is", "$1$2<a href=\"$3\" target='_blank'><b>".$lang_live_chat['Link']."</b></a>", $text); 
		
    $text= preg_replace("/(^|[\n ])([\w]*?)((www)\.[^ \,\"\t\n\r<]*)/is", "$1$2<a href=\"http://$3\" target='_blank'><b>".$lang_live_chat['Link']."</b></a>", $text); 

    return($text);
}

function parse_smilies($text)
{
	global $forum_config, $base_url;
	
	if ($forum_config['o_live_chat_use_smilies'] == '1') {
	    require FORUM_ROOT.'extensions/live_chat/smilies/smilies.php';
	} else {
		if (!defined('FORUM_PARSER_LOADED'))
			require FORUM_ROOT.'include/parser.php';
		
		if (!isset($smilies))
		    global $smilies;
	}

	$text = ' '.$text.' ';

	foreach ($smilies as $smiley_text => $smiley_img)
	{
		if (strpos($text, $smiley_text) !== false)
			$text = preg_replace("#(?<=[>\s])".preg_quote($smiley_text, '#')."(?=\W)#m", '<img src="'.$base_url.'/extensions/live_chat/smilies/img/'.$smiley_img.'" alt="'.substr($smiley_img, 0, strrpos($smiley_img, '.')).'" />', $text);
	
	    if (forum_htmlencode(stripslashes($smiley_text)) != $smiley_text)
		{
		    if (strpos($text, forum_htmlencode(stripslashes($smiley_text))) !== false)
			    $text = preg_replace("#(?<=[>\s])".preg_quote(forum_htmlencode(stripslashes($smiley_text)), '#')."(?=\W)#m", '<img src="'.$base_url.'/extensions/live_chat/smilies/img/'.$smiley_img.'" alt="'.substr($smiley_img, 0, strrpos($smiley_img, '.')).'" />', $text);

		}
	}

	if ($forum_config['o_live_chat_use_smilies'] != '1') {
	    $text = str_replace('extensions/live_chat/smilies/img/', $forum_config['o_live_chat_smilies_folder'], $text);
	}

	return substr($text, 1, -1);
}

function get_adjusted_date($d) 
{
	global $lang_live_chat;

    $d_diff = time() - $d;
    if ($d_diff < 3600) {
	    $res = floor($d_diff / 60);
        if ($res == 0) {
            return $lang_live_chat['Now'];
		} else {
			return $res.' '.padezh_of_date($res, $lang_live_chat['Minute ago'], $lang_live_chat['Minutes ago'], $lang_live_chat['Minutes of ago']);
		}
    } else {
        return format_time($d);
	}
}

function padezh_of_date($num, $p1, $p2, $p5)
{
    $x = $num % 100;
    $y = ($x % 10)-1;
    $res = ($x/10)>>0==1 ? $p5 : ($y&12 ? $p5 : ($y&3 ? $p2 : $p1));

    return $res;
}

function translit_attach_file($str) 
{
    $tr = array(
        "А" => "A",
        "Б" => "B",
        "В" => "V",
        "Г" => "G",
        "Д" => "D",
        "Е" => "E",
        "Ж" => "ZH",
        "З" => "Z",
        "И" => "I",
        "Й" => "I",
        "К" => "K",
        "Л" => "L",
        "М" => "M",
        "Н" => "N",
        "О" => "O",
        "П" => "P",
        "Р" => "R",
        "С" => "S",
        "Т" => "T",
        "У" => "U",
        "Ф" => "F",
        "Х" => "H",
        "Ц" => "TS",
        "Ч" => "CH",
        "Ш" => "SH",
        "Щ" => "SHCH",
        "Ъ" => "",
        "Ы" => "Y",
        "Ь" => "'",
        "Э" => "E",
        "Ю" => "IU",
        "Я" => "IA",
        "Г" => "G",
        "Ї" => "YI",
        "І" => "I",
        "Є" => "E",
        "а" => "a",
        "б" => "b",
        "в" => "v",
        "г" => "g",
        "д" => "d",
        "е" => "e",
        "ж" => "zh",
        "з" => "z",
        "и" => "i",
        "й" => "i",
        "к" => "k",
        "л" => "l",
        "м" => "m",
        "н" => "n",
        "о" => "o",
        "п" => "p",
        "р" => "r",
        "с" => "s",
        "т" => "t",
        "у" => "u",
        "ф" => "f",
        "х" => "h",
        "ц" => "ts",
        "ч" => "ch",
        "ш" => "sh",
        "щ" => "shch",
        "ъ" => "",
        "ы" => "y",
        "ь" => "'",
        "э" => "e",
        "ю" => "iu",
        "я" => "ia",
        "г" => "g",
        "ї" => "yi",
        "і" => "i",
        "є" => "e",
        "ё" => "e",
        "Ё" => "e",
        " " => "_",
        "." => ".",
        ":" => "",
        ";" => "",
        "/" => "_"
    );

    return strtr($str, $tr);
}

