
var chat_content = 1;
var chat_interval;
var chat_settings = $('#chat_settings');
var chat_msg = document.getElementById('message');
var public_maxlength = chat_settings.attr('public_maxlength');
var private_maxlength = chat_settings.attr('private_maxlength');
var chat_msg_length_counter = $('.chat_msg_length_counter');

$(document).ready(function() {
    RereshChat();
	SetChatRefresh('start');
});

$(function() {
    var hideDelay = 500;  
    var hideTimer = null;
    var cp_popup = $('<div id="chat_user_profile"></div>');

    $('#chat_body').append(cp_popup);
	$(document).on('mouseover', '.chat_profile', function() {
        var msg_id = $(this).attr('msg_id');
	    var u_status = $(this).attr('user_status');
		var msg_side = $(this).attr('side');

        cp_popup.removeClass().addClass(u_status);

        if (hideTimer)
            clearTimeout(hideTimer);

//		var c_pos = $('#chat_result').offset();
		var m_pos = $(this).offset();

		if (msg_side == 'my') {
			cp_popup.css({left: '', right: '21px', top: (m_pos.top + 49) + 'px'});
		} else {
			cp_popup.css({right: '', left: '21px', top: (m_pos.top + 49) + 'px'});
		}

	    $.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=user_data',{msg_id:msg_id, u_status:u_status},function(data){
		       if (data.length > 0){
				   cp_popup.show().html(data);
			   }
	    });
    });

	$(document).on('mouseout', '.chat_profile', function() {
        if (hideTimer)
            clearTimeout(hideTimer);
        hideTimer = setTimeout(function() {
			cp_popup.hide();
        }, hideDelay);
    });

    $('#chat_user_profile').mouseover(function() {
        if (hideTimer)
            clearTimeout(hideTimer);
    });

    $('#chat_user_profile').mouseout(function() {
        if (hideTimer)
            clearTimeout(hideTimer);
        hideTimer = setTimeout(function() {
			cp_popup.hide();
        }, hideDelay);
    });
});

$(document).on("focus input keyup change", "#message", function() {
	var curlength = $(this).val().replace(/\[\s*img.*\][^[]*\[\s*\/img.*\]|\[[^\]]+\]|\[\s*quote.*\][^[]*\[\s*\/quote.*\]|\[[^\]]+\]/g, "").length;
    var maxlength = chat_msg_length_counter.find('span:last').text();
    chat_msg_length_counter.find('span:first').html(curlength);
	if (curlength >= maxlength) {
		chat_msg_length_counter.css( 'color', 'red' );
		$(this).attr('maxlength', maxlength);
	} else {
		chat_msg_length_counter.css( 'color', '' );
		$(this).attr('maxlength', '');
	}
    flexibleTextarea();
});	

$(document).on("focus input keyup change", "[id^='edited_chat_msg_']", function(){
	var curlength = $(this).val().replace(/\[\s*img.*\][^[]*\[\s*\/img.*\]|\[[^\]]+\]|\[\s*quote.*\][^[]*\[\s*\/quote.*\]|\[[^\]]+\]/g, "").length;
	var maxlength = chat_msg_length_counter.find('span:last').text();
	var cur_chat_msg_length = $(this).parent().find('span:last');
    cur_chat_msg_length.text(curlength);
	if (curlength >= maxlength) {
		cur_chat_msg_length.css( 'color', 'red' );
		$(this).attr('maxlength', maxlength);
	} else {
		cur_chat_msg_length.css( 'color', '' );
		$(this).removeAttr('maxlength');
	}
});

$(document).on("keydown", "#message, #chat_author", function(e) {
    if ((e.keyCode == 10 || e.keyCode == 13) && e.ctrlKey)
    {
        AddChatMessage();
    }
});

function Chat_menu_tab(tab) {
	$('#chat_settings').text(tab);
	$("#chat_menu li").removeClass('active');
	$("#chat_menu li:nth-child("+tab+")").addClass('active');
	$('#r_user_id').val('');
	unsetOldVisualNotify();
	RereshChat();
	if (chat_content < 1) {
	    chat_content = 1;
	}
}

function Private_chat(id) {
	$('#r_user_id').val(id);
    $('#chat_settings').text(2);
	$("#chat_menu li").removeClass('active');
	$("#chat_menu li:nth-child(2)").addClass('active');
	RereshChat();
	if (chat_content < 1) {
	    chat_content = 1;
	}
}

function AddChatMessage() {
	var chat_tab = $('#chat_settings').eq(0).text();
	var user_id = $('#r_user_id').val();
	$.ajax({
		url: PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=add',
        type: 'post',
	    dataType: 'json',
		data: $('#chat_msg_form').serialize() + '&' + $.param({tab:chat_tab, user_id:user_id}),
            success: function(data) {
				if (data.answer == 'success') {
				    $('#chat_msg_form')[0].reset();
					$('#chat_error').hide();
					chat_msg.rows = 4;
					chat_msg_length_counter.find('span:first').html(0);
					chat_msg_length_counter.css( 'color', '' );
					unsetOldVisualNotify();
					RereshChat();
			    } else {
					$('#chat_error').fadeIn(500).empty().html(data.error);
					setTimeout(function(){
                       $('#chat_error').fadeOut(500);
                    },7000);
				}
            },
            error: function(response) {
                $('#chat_error').fadeIn(500).empty().html('When you send a message an error has occurred.');
				setTimeout(function(){
                    $('#chat_error').fadeOut(500);
                },7000);
            }
    });
}

function AttachChatFile() {
	$('.loader').show();
	$('#chat_attach').attr('disabled','disabled');
	var af = new FormData();
	var chat_tab = $('#chat_settings').eq(0).text();
	var user_id = $('#r_user_id').val();
	af.append('tab', chat_tab);
	af.append('user_id', user_id);
	af.append( 'file', $('input[type=file]')[0].files[0]);
	$.ajax({
		url: PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=upload_file',
		type: 'POST',
		dataType: 'json',
		cache: false,
		processData: false,
		contentType: false,
		data: af,
		    success: function(data) {
				if (data.answer == 'success') {
					$('.loader').hide();
                    $('#chat_attach').removeAttr('disabled','disabled').val('');
					$('#chat_error').hide();
					unsetOldVisualNotify();
					RereshChat();
			    } else {
					$('.loader').hide();
					$('#chat_attach').removeAttr('disabled','disabled').val('');
					$('#chat_error').fadeIn(500).empty().html(data.error);
					setTimeout(function(){
                       $('#chat_error').fadeOut(500);
                    },7000);
				}
            },
            error: function(response) {
				$('.loader').hide();
                $('#chat_error').fadeIn(500).empty().html('When you send a message an error has occurred.');
				setTimeout(function(){
                    $('#chat_error').fadeOut(500);
                },7000);
            }
	});
}

function RereshChat() {
	var chat_tab = $('#chat_settings').eq(0).text();
	var user_id = $('#r_user_id').val();
	var chat_sound = $('#chat_settings').attr('chat_sound');
	var visual_notify = $('#chat_settings').attr('visual_notification');
	var chat_user_status = $('#chat_user_status').val();
    $.ajaxSetup ({
        cache: false
    });

	$.getJSON(PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=refresh',{tab:chat_tab, user_id:user_id},function(data) {

	    if (data.answer == 'success') {

			if (chat_tab == 4) {
				if ($('#chat_features').length < 1) {
					$('#chat_result').attr('id', 'chat_features').css( 'max-height', 'unset' );
		            $('#chat_features').empty().html(data.content);
				}
			} else {
				if ($('#chat_features').length > 0) {
				    $('#chat_features').attr('id', 'chat_result');
					getChatHeight();
				}
		        $('#chat_result').empty().html(data.content);
			}
			
            if (chat_content > 0) {
				if (chat_tab == 1 || chat_tab == 2 && user_id > 0) {
					Scroll();
				} else if (chat_tab == 3) {
					Scroll('up');
				}
				chat_content = 0;
			}
			
			if (chat_tab == 2 && data.box_count != 0) {
				if ($('.chat_attention').is(':hidden')) {
			        $('.chat_attention').hide().fadeIn(1000).empty().html(data.box_count);
				}
			} else {
				$('.chat_attention').hide();
			}

			if (data.head_desc != 0) {
			    $('.head-description').show().empty().html(data.head_desc);
			} else {
				$('.head-description').hide();
			}
			
	        if (data.show_form == 1) {
			    $('#chat_msg_form, #chat_buttons, #chat_status_box').show();
				if (data.upload_button == 1) {
			        $('.attach_block').show();
			    } else {
				    $('.attach_block').hide();
			    }
				if (data.admin_button == 1) {
			        $('.admin_func').show();
			    } else {
				    $('.admin_func').hide();
			    }
			} else {
				$('#chat_smilies, #chat_msg_form, #chat_buttons, #chat_status_box').hide();
				$('.attach_block').hide();
				$('.admin_func').hide();
			}
			
			if ($('#chat_msg_form').length < 1) {
				window.location.reload(PUNBB.env.base_url);
			}
			
			if (chat_tab == 1) {
		        chat_msg_length_counter.find('span:last').html(public_maxlength);
	        } else if (chat_tab == 2) {
		        chat_msg_length_counter.find('span:last').html(private_maxlength);
	        }
			
			if (chat_tab == 2 && data.show_form == 1) {
                var msg_count = $('.head-description').find('span:last').text().replace(/^(.*\()([^\)]+)(\).*)/, '$2');
				if (msg_count > 0) {
					$(".clear_chat").show();
				} else {
					$(".clear_chat").hide();
				}
			} else {
				$(".clear_chat").hide();
			}
			
		    public_result = $('#chat_settings').attr('public_last_entry');
		    if (data.public_last_entry != 0 && data.public_last_entry > public_result) {
			    if (chat_sound > 0) {
		            $('<audio id="chatAudio"><source src="'+PUNBB.env.base_url+'/extensions/live_chat/sounds/notify.ogg" type="audio/ogg"><source src="'+PUNBB.env.base_url+'/extensions/live_chat/sounds/notify.mp3" type="audio/mpeg"></audio>').appendTo('#chat_result');
			        $('#chatAudio')[0].play();
	            }
			    $('#chat_settings').attr('public_last_entry', data.public_last_entry);
				Scroll();
		    }
			
			private_result = $('#chat_settings').attr('private_last_entry');
		    if (data.private_last_entry != 0 && data.private_last_entry > private_result) {
			    if (chat_sound > 0) {
		            $('<audio id="chatAudio"><source src="'+PUNBB.env.base_url+'/extensions/live_chat/sounds/notify.ogg" type="audio/ogg"><source src="'+PUNBB.env.base_url+'/extensions/live_chat/sounds/notify.mp3" type="audio/mpeg"></audio>').appendTo('#chat_result');
			        $('#chatAudio')[0].play();
	            }
				$('#chat_settings').attr('private_last_entry', data.private_last_entry);
				Scroll();
		    }
			
			if (visual_notify > 0) {
		        if (data.public_notify > 0) {
			        $('#chat_menu').find('span:first').show().empty().html(data.public_notify);
			    } else {
					$('#chat_menu').find('span:first').hide();
				}
			    if (data.private_notify > 0) {
			        $('#chat_menu').find('span:last').show().empty().html(data.private_notify);
			    } else if (chat_tab == 2 && user_id > 0) {
					$('#chat_menu').find('span:last').hide();
				}
			}
			
			if (data.user_status == 4 && data.user_status != chat_user_status) {
				$('#chat_user_status option[value="4"]').prop('selected', true);
				$('#chat_user_status').prop('disabled', true);
			} else if (chat_user_status == 4 && data.user_status != 4) {
				$('#chat_user_status option[value="1"]').prop('selected', true);
                $.map($('#chat_user_status option'), function(ele) {
                    if (ele.value < 4) {
						$('#chat_user_status option[value="' +ele.value+ '"]').show();
	                } else {
						$('#chat_user_status option[value="' +ele.value+ '"]').hide();
					}
                });
				$('#chat_user_status').prop('disabled', false);
			}
		} else {
			if ($('#chat_msg_form').length < 1) {
			    $('#chat_result').empty().html(data.content);
			} else {
				window.location.reload(PUNBB.env.base_url);
			}
	    }
	});
}

function SetChatRefresh(set) {
	var chat_refresh = $('#chat_settings').attr('chat_refresh');
	if (set == 'start') {
		if (chat_refresh > 0) {
		    chat_interval = setInterval('RereshChat()', chat_refresh * 1000);
	    }
	} else {
		clearInterval(chat_interval);	
	}
}

function Scroll(route) {
	var chat_inversion = $('#chat_settings').attr('chat_inversion');
    if (chat_inversion == 1 || route == 'up') {
		$('#chat_result').animate({ scrollTop:0 }, 80);
	} else {
		$("#chat_result").animate({ scrollTop: $('#chat_result')[0].scrollHeight - $('#chat_result')[0].clientHeight }, 80);
	}
}

function Get_chat_user(el) {
	var u_id = el.getAttribute('user_id');
	var u_name = el.getAttribute('user_name').replace(/\s*\[(guest|гость)*?\]\s*/g, '');
	var c_user = " [user="+u_id+"]"+u_name+"[/user], ";
	Insert_tag(c_user);
}

function Get_smile(smiley) {
	anichange ('#chat_smilies');
	Insert_tag(smiley);
}

function Insert_tag(tag) {
    var text_area = Get_insert_area();
	var el = text_area, newStart;
	var maxlength = el.getAttribute('maxlength');
	var curlength = el.value.length;
	
	if ((maxlength != null && maxlength > 0) && (curlength >= maxlength)) {
		return false;
	}
			
    if ('selectionStart' in el) {
		newStart = el.selectionStart + tag.length;
		el.value = el.value.substr(0, el.selectionStart) + tag + el.value.substr(el.selectionEnd, el.value.length);
		el.setSelectionRange(newStart, newStart);
	} else if (document.selection) {
		document.selection.createRange().text = tag;
	}
					
	el.focus();
}

function Insert_many_tags(start_tag, end_tag) {
    var text_area = Get_insert_area();
	var el = text_area;
	var maxlength = el.getAttribute('maxlength');
	var curlength = el.value.length;
	
	if ((maxlength != null && maxlength > 0) && (curlength >= maxlength)) {
		return false;
	}
	
    var s_tag = start_tag;
    if (end_tag) {
        var e_tag = end_tag;
    } else {
        var e_tag = '';
    }
    var IE = /*@cc_on!@*/false;

    if (IE) {
        var r = document.selection.createRange();
        var tr = el.createTextRange();
        var tr2 = tr.duplicate();
        tr2.moveToBookmark(r.getBookmark());
        tr.setEndPoint('EndToStart',tr2);
        var tag_val = s_tag + r.text + e_tag;
        var the_start = el.value.replace(/[\r\n]/g,'.').indexOf(r.text.replace(/[\r\n]/g,'.'),tr.text.length);
        el.value = el.value.substring(0, the_start) + tag_val + el.value.substring(the_start + tag_val.length, el.value.length);

        var pos = el.value.length - e_tag.length;
        tr.collapse(true);
        tr.moveEnd('character', pos);
        tr.moveStart('character', pos);
        tr.select();
    } else if (el.selectionStart || el.selectionStart == "0") {
        var startPos = el.selectionStart;
        var endPos = el.selectionEnd;
        var tag_val = s_tag + el.value.substring(startPos, endPos) + e_tag;
        el.value = el.value.substring(0, startPos) + tag_val + el.value.substring(endPos, el.value.length);

        el.setSelectionRange((endPos+s_tag.length),(endPos+s_tag.length));
        el.focus();
    }

    return tag_val;
}

function Get_insert_area() {
	var text_area = $('[id^="edited_chat_msg_"]');
    if (text_area.length > 0) {
		var temp_msg = text_area.attr('id');
		return document.getElementById(temp_msg);
	} else {
		return document.getElementById('message');
	}
}

function anichange (objName, needBlok) {
	if (needBlok) {
	    var b_position = $(needBlok).position();
	    var b_height = $(needBlok).height();
        var o_height = $(objName).height();
	    var o_position = b_position.top + b_height - o_height;

	    $(objName).css( 'top', o_position+'px' );
	}

   if ( $(objName).css('display') == 'none' ) {
        $(objName).animate({ height : "show" }, 200, "swing");
		if (objName == '#chat_body, .admin-submenu') {
		    $('.collapsable').removeClass('collapsed');
		}
		
   } else {
        $(objName).animate({ height : "hide" }, 200, "swing");
		if (objName == '#chat_body, .admin-submenu') {
		    $('.collapsable').addClass('collapsed');
		}
   }
}

function Change_user_color(color) {
    $.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=user_color',{color:color},function(){
		ShowNotification('color');
	    RereshChat();
	});
}

function Sound_notification() {
    $.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=sound_notification', function(data){
		if (data == 1) {
			$('#chat_settings').attr('chat_sound', 1);
			$('.sound_notif').removeClass('sound_off').addClass('sound_on');
			ShowNotification('sound', 1);
        } else if (data == 0) {
			$('#chat_settings').attr('chat_sound', 0);
			$('.sound_notif').removeClass('sound_on').addClass('sound_off');
			ShowNotification('sound', 0);
		} else {
			ShowNotification('sound', 2);
		}
        RereshChat();
    });
}

function User_status(sel) {
	var user_status = sel.value;
	$.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=user_status',{u_status:user_status},function(data){
		if (data == 1) {
			$('#chat_settings').attr('chat_sound', 1);
		    $('.sound_notif').removeClass('sound_off').addClass('sound_on');
		} else if (data == 0) {
			$('#chat_settings').attr('chat_sound', 0);
			$('.sound_notif').removeClass('sound_on').addClass('sound_off');
		}
		ShowNotification('status');
		RereshChat();
	});
}

function Admin_functions() {
	var a_func = $(".footer_msg").css("display");
	if (a_func == 'block') {
		func = 'none';
	} else {
		func = 'block';
	}
    $.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=admin_functions',{func:func},function(){
		if (a_func == 'block') {
		    ShowNotification('moderator', 0);
	    } else {
			ShowNotification('moderator', 1);
	    }
	    RereshChat();
	});
}

function Delete_message(id) {
    $.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=delete_msg',{msg_id:id},function(){
		ShowNotification('delete', 1);
	    RereshChat();
	});
}

function Delete_private_message(id) {
	var user_id = $('#r_user_id').val();
    $.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=delete_private_msg',{msg_id:id, user_id:user_id},function(){
		if (id) {
		    ShowNotification('delete', 1);
		} else {
			ShowNotification('delete', 0);
		}
	    RereshChat();
	});
}

function Edit_message(id) {
	SetChatRefresh('stop');
	var chat_tab = $('#chat_settings').eq(0).text();
    var msg = $('.edit_chat_msg_'+id);
	if (msg.css('display') != 'none' && $('#chat_msg_editor_'+id).length < 1) {
		if ($('[id^="chat_msg_editor_"]').length > 0) {
            $('[id^="chat_msg_editor_"]').each(function(){
				var cm_id = $(this).attr('id').split('chat_msg_editor_')[1]; 
				$('.edit_chat_msg_'+cm_id).show();
				$('#chat_msg_editor_'+cm_id).remove();
            });
		}

        var t_height = msg.outerHeight();
		var m_width = msg.prev().outerWidth();
		
		$.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=edit_message',{tab:chat_tab, msg_id:id},function(data){
		       if (data.length > 0){
				   msg.hide().after('<div class="frame_edit_chat_msg" id="chat_msg_editor_'+id+'"><textarea id="edited_chat_msg_'+id+'" class="editing_msg" style="width:'+m_width+'px; height:'+(t_height * 2)+'px;">' +data+ '</textarea><span class="sp chat_msg_update" onclick="Update_chat_msg('+id+');">Сохранить</span>&nbsp;&nbsp;<span class="sp chat_msg_edit_cancel" onclick="Close_msg_editor('+id+');">Отмена</span><span class="sp chat_msg_length"></span></div>');
			   }
	    });
    } else {
		$('#chat_msg_editor_'+id).remove();
		msg.show();
		SetChatRefresh('start');
    }
}

function Close_msg_editor(id) {
	$('#chat_msg_editor_'+id).prev('.text_msg').show().end().remove();
    SetChatRefresh('start');
}

function Update_chat_msg(id) {
	var chat_tab = $('#chat_settings').eq(0).text();
	var msg_text = $('#edited_chat_msg_'+id).val();
	$.ajax({
		url: PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=update_message',
        type: 'post',
        data: ({'tab': chat_tab, 'msg_id': id, 'text': msg_text}),
            success: function() {
				ShowNotification('edit');
                RereshChat();
                SetChatRefresh('start');
            },
            error: function(response) {
            }
    });
}

function Silent_user(id) {
    $.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=silent',{user_id:id},function(data){
		if (data > 1) {
		    ShowNotification('silent', 1);
		} else {
			ShowNotification('silent', 0);
		}
	    RereshChat();
	});
}

function Ban_user(id) {
    $.get( PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=ban',{msg_id:id},function(data){
		if (data == 1) {
		    ShowNotification('banned', 1);
		} else {
			ShowNotification('banned', 0);
		}
	    RereshChat();
	});
}

function SaveChatSettings() {
	$.ajax({
		url: PUNBB.env.base_url+'/extensions/live_chat/ajax.php?action=save_settings',
        type: 'post',
	    dataType: 'json',
        data: $('#chat_settings_form').serialize(),
            success: function(data) {
				if (data.answer == 'success') {
					$('#chat_settings').remove();
					$("#chat_notify").before(data.content);
				    if ($('#chat_settings').length > 0) {
					    ShowNotification('settings');
					} else {
		               window.location.reload(PUNBB.env.base_url);
				    }
				}
            },
            error: function(response) {
            }
    });
}

function ShowNotification(notify, val) {
	var chat_notify = $('#chat_settings').attr('chat_notify');
	var div = $('#chat_notify');
	var sound_on = div.attr('sound_on');
    var sound_off = div.attr('sound_off');
	var sound_unavailable = div.attr('sound_unavailable');
    var moderator_on = div.attr('moderator_on');
	var moderator_off = div.attr('moderator_off');
    var deleted = div.attr('deleted');
	var cleared = div.attr('cleared');
	var edited = div.attr('edited');
    var silent_on = div.attr('silent_on');
	var silent_off = div.attr('silent_off');
	var ban_on = div.attr('ban_on');
	var ban_off = div.attr('ban_off');
    var nickname_color = div.attr('nickname_color');
	var user_status = div.attr('status');
	var save_settings = div.attr('settings');
	
	if (notify == 'sound') {
		if (val == 0) {
			msg = sound_off;
		} else if (val == 1) {
			msg = sound_on;
		} else {
			msg = sound_unavailable;
		}
	} else if (notify == 'moderator') {
		if (val == 1) {
			msg = moderator_on;
		} else {
			msg = moderator_off;
		}
    } else if (notify == 'delete') {
		if (val == 1) {
			msg = deleted;
		} else {
			msg = cleared;
		}
	} else if (notify == 'edit') {
			msg = edited;
	} else if (notify == 'silent') {
		if (val == 1) {
			msg = silent_on;
		} else {
			msg = silent_off;
		}
	} else if (notify == 'banned') {
		if (val == 1) {
			msg = ban_on;
		} else {
			msg = ban_off;
		}
	} else if (notify == 'color') {
			msg = nickname_color;
	} else if (notify == 'status') {
			msg = user_status;
	} else if (notify == 'settings') {
			msg = save_settings;
	}

	if (chat_notify > 0) {
        if ($(".notify").length > 0) {
		    $('.notify').remove();
			clearTimeout(n_timeout);
	    }
	    $('#chat_body').prepend('<span class="notify">' +msg+ '</span>');
	    $('.notify').hide().fadeIn(500);
	    n_timeout = setTimeout(function(){
            $('.notify').remove();
        },2500);
	}
}

function getChatHeight() {
	var chat_height = $('#chat_settings').attr('chat_height');
	$('#chat_result').css( 'max-height', chat_height+'px' );
}

function flexibleTextarea(){
	var t_area = chat_msg;
	var minRows = 4;
    t_area.rows = minRows;

	do {
	   if (t_area.clientHeight != t_area.scrollHeight) t_area.rows += 1;
	} while (t_area.clientHeight < t_area.scrollHeight);
}

function unsetOldVisualNotify() {
	var visual_notify = $('#chat_settings').attr('visual_notification');
	if (PUNBB.env.user_is_guest == 0 && visual_notify > 0) {
		var cur_date = Math.round(new Date().getTime() / 1000);
		var date = new Date();
//		date.setTime(date.getTime()+(1*24*60*60*1000));
		date.setTime(date.getTime()+(30*24*60*60*1000));
        document.cookie = "chat_public_last_notify=" + cur_date + "; expires=" + date.toGMTString() + "; path=/";
	}
}
